/*
 * file		: gamtsp.c
 * system	: `ASYga1()̃eXgp
 * function	: Z[X}̗
 * auther	: 2012.12.14 Y.Shibasaki
 */
#pragma warning(disable:4996)

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<malloc.h>
#include	<memory.h>
#include	<time.h>
#include	"ssc.h"
//#include	"gaparm.h"
//#define _USE_MATH_DEFINES  // M_PÎ
#include <math.h>
//#define M_PI	   3.14159265358979323846
#include "ga1.h"
#include "gatsp.h"
/****************/


// w苗Ń[g؂Ƃ̃[gԂ */
static int get_route_num(  /* [g */
int		num,		/* i _ */
int		ans[],		/* i _̈ʒu */
int		start,		/* i Jnʒu@OȊO̎́AŏI_擪_ʂA擪_ɖ߂܂ł̃[gl */
double	**sagyo,	/* i e_Ԃ̋ */
double	*len,		/* io [giZ[gɕj */
int		ret_ans[],	/* o ؂ꂽ_̈ʒu NULL̂Ƃ́AɃZbgȂij*/
class GA1 *ga0)
{
	int 	i, j, first, next, cnt = 0, rcnt = 0, acnt = 0;
	double	total = 0.0, old_total, max;
	CHKB ( EPS,(*len),(*len) ) ;
	if(DBGF[25]) fprintf(logfp,"***** start(%d) len(%lf)\n",start,(*len)); fflush(logfp);
	max = 0; rcnt = 0;
	for ( i = start; i < num+start-1; i++ ) {
		if( i >= num ) j = i - num;
		else           j = i;
		first = ans[j];			CHKA(0,first,num);
		if( j+1 == num ) 	next = ans[0];
		else				next = ans[j+1];
			CHKA(0,next,num);
		old_total = total;
		total += sagyo[first][next];
		if( ret_ans != NULL ) {	ret_ans[rcnt] = first;	rcnt++;	}
		if( total > *len) { /* [g𒴂 */
			/* P_݂̂Ȃ */
			if( old_total == 0.0 )if(DBGF[25]) fprintf(logfp,"rout%d) %d -> %lf\n",cnt+1, j, old_total); 
			if( old_total > max ) max = old_total;  CHKAD(old_total ,(*len),total);
			cnt++;
			total = 0;
			if( ret_ans != NULL ) {
				ret_ans[rcnt] = ga0->gap.gene_number + acnt; /* ؂苒_͋_ȍ~̐ */
				rcnt++; acnt++;
			}
		}
		else {
			if(DBGF[25]) fprintf(logfp,"rout%d) %d-%d (%lf) -> %lf\n",cnt+1, j, j+1,sagyo[first][next],total); 
		}
	}
	if( ret_ans != NULL ) {	ret_ans[rcnt] = next;	rcnt++;	}

	/* ŌɂP_݂̂Ȃ */
	if( total == 0.0 )if(DBGF[25]) fprintf(logfp,"rout%d) %d -> %lf\n",cnt+1, j, total); 

	/* Ō̃g[^r */
	if( total > max ) max = total;  //CHKAD(old_total ,total,(*len));

	*len = max;
	if(DBGF[25]) fprintf(logfp,"*len(%lf) rout_num(%d)\n",*len, cnt); fflush(logfp);
	return( cnt+1 ) ;
}
/* TSP̌ʂAől[gŏ̕[gĂ */
double gamtsp(  /* [g̍ől */
int		t_ans_num,		/* i TSP̉̐ */
int		t_ans[],		/* i TSP̉ */
int		route_num,		/* i [g */
double	**sagyo,		/* i e_Ԃ̋ */
int		m_ans[],		/* o MTSP̉ */
class GA1 *ga0)
{
	double	rc = 0.0;
	int 	i, first, next, start, route_num1, *w_ans = NULL, save_start, rcnt;
	double	total = 0.0, temp_length, old_temp_length, max, min, save_temp_length, save_temp_length1, s_num;

	CHKB(2,route_num,ga0->gap.gene_number);
	/* MTSP̉ꎞi[pGA */
	//if( (w_ans = (int*) malloc((ga0->gap.gene_number+ga0->gap.allele_number)*sizeof(*w_ans))) == 0 ) goto   quit;
	/* bli[g̍őljZo */
	/* blS[g */
	for ( i = 0; i < t_ans_num	; i++ ) {
		first = t_ans[i];			CHKA(0,first,t_ans_num);
		if( i+1 == t_ans_num ) 	next = t_ans[0];
		else							next = t_ans[i+1];
			CHKA(0,next,t_ans_num);
		total += sagyo[first][next];
	}
	temp_length = total / route_num;
	save_temp_length = save_temp_length1 = total;
	for( start = 0; start < t_ans_num; start++ )  { /* S_n_ɂČ@*/
		if( start == 10 ) {
			start = start ;
		}
		/* blł̃[g擾 */
		min = 0.0; max = temp_length *2;
		do {
			old_temp_length = temp_length;
			route_num1 = get_route_num(t_ans_num, t_ans, start, sagyo, &temp_length,NULL,ga0);
			/* [g  w胋[g@*/
			if( route_num1 < route_num ) {
				/* blύXi[j@*/
				max = temp_length;
				temp_length -= (temp_length - min) / 2;
			}
			/* [g@@w胋[g@*/
			else if( route_num1 > route_num ) {
			/* blύXi{j@*/
				min = old_temp_length;
				temp_length = old_temp_length + (max - old_temp_length) / 2;
			}
			/* [g@@w胋[g@*/
			else {
				/* blύXi[j@*/
				max = save_temp_length1 = temp_length;
				temp_length -= (temp_length - min) / 2;
			}

		/* blςȂȂiOɂȂjI */
		} while( max - min > EPS ) ;
		if( save_temp_length1 < save_temp_length ) {
			/* m_ans[]Ƀ}`̉ ؂ԍ̑} */
			route_num1 = get_route_num(t_ans_num, t_ans, start, sagyo, &save_temp_length1,m_ans,ga0); CHKB(route_num,route_num1,route_num);
			//memcpy(m_ans,w_ans,(ga0->gap.gene_number+ga0->gap.allele_number-1)*sizeof(*w_ans));
			save_temp_length =  save_temp_length1 ;
			save_start = start;
		}
	}
	/* n_ςĎs@*/
	/* 擪[g̊e_ɂāAvZ */
	/* 
	/* blłnjȂAbl炵Ďs */
	/* ŏ̎bl */
	/* n_́AŏɌ[ĝPɂ_łiׂĂ̓_ɂĎsKvȂj<=@E\I */

	/* t[ */
	//if( w_ans != NULL) free(w_ans);
//quit:	
	if(DBGF[25]) {
		for( i =0; i < ga0->gap.gene_number+ga0->gap.allele_number-1; i++ ) {
			fprintf(logfp,"m_ans[%d]= %d\n",i, m_ans[i] ); fflush(logfp);
		}
		fprintf(logfp,"start(%d) length(%lf)\n",save_start,save_temp_length ); fflush(logfp);
		rcnt = 0;total = 0;
		fprintf(logfp,"route(%d)\n", rcnt++);
		for( i =0; i < ga0->gap.gene_number+ga0->gap.allele_number-2; i++ ) {
			first = m_ans[i]; next = m_ans[i+1];
			if( first >= ga0->gap.gene_number ) {
				total = 0.0;
				fprintf(logfp,"route(%d)\n", rcnt++);
			}
			else if( next >= ga0->gap.gene_number ) continue;
			else {
				s_num = sagyo[first][next];
				total += s_num;
				fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);
			}
		}fflush(logfp);
	}
return(rc);	
}
int		gatsp_part_make(
int			no;
class GATSP	*ga0,
class GA1	*ga0,
class GATSP	*gatsp2,
class GA1	*ga2)
{
	int rc = 0, *m_ans, pos = -1, cnt = 0;

	/* gene_number̃JEg */
	for( i = 0; i < ga0->

{
}
/* TSP̌ʂ[gɕĂ݂ 2013.04.08 */
int gaMTSP( 
	class GA1 *ga0,
	class GA1	*ga0)
{
	int rc = 0, *m_ans, pos = -1, cnt = 0;
	//int	i, first, next, *m_ans2;
	double	len;
	class GATSP	gatsp2;
	class GA1	ga2;

/* IMADAKE */
	ga0->gap.allele_number = 4;
	DBGF[25] = 1;

	if( (m_ans = (int*) malloc((ga0->gap.gene_number+ga0->gap.allele_number)*sizeof(*m_ans))) == 0 ) goto   quit;
	/* ől[gŏ̕[g */
	len = gamtsp(  ga0->gap.gene_number, ga0->ans, ga0->gap.allele_number, ga0->sagyo, m_ans, ga0 );
	// e[gɂāAsrof`s
	for( i = 0; i < ga0->gap.allele_number; i++ ) {
		gatsp_part_make(i, ga0, ga0, &gatsp2, &ga2);
	}

#ifdef Z0 // Cł͎̂߁@b{{ֈڐAI@bł͓rA܂Ł@2013.04.17
	/* sagyo[]̑ޔ etc */
	if( (m_ans2 = (int*) malloc((gap.gene_number+gap.allele_number)*sizeof(*m_ans2))) == 0 ) goto   quit;
	/* e[gɂčēxsroĂ݂āAŒZ̃[gT */
	for( i =0; i < gap.gene_number+gap.allele_number-2; i++ ) {
		first = m_ans[i]; next = m_ans[i+1];
		if( pos == -1  && first < gap.gene_number ) pos = i;
		if( first >= gap.gene_number ) {
			rc = func_tsp2(&m_ans[pos], cnt,&m_ans2[pos]);
		}
		else {
			cnt++;
		}
	}
#endif // C -> C++  ֕ύX@rA܂

quit:
	return(rc);
}

