/*
 * file		: Lstsp.c
 * system	: `ASYga1()̃eXgp
 * function	: Z[X}̗
 * auther	: 2012.12.14 Y.Shibasaki
 */
#pragma warning(disable:4996)

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<malloc.h>
#include	<memory.h>
#include	<time.h>
#include	"ssc.h"
#include <math.h>
//#define M_PI	   3.14159265358979323846
#include "ga1.h"
#include "lstsp.h"

/*	ID_get_time	idx1 ` idx2 ̍sԂ߂
***************************************************************************/
static double get_time(
	int idx1,			 //i ans[] ̃CfNX
	int idx2,			 //i ans[] ̃CfNX
	int *ansL,			 //i sagyo[][]̃CfNXi[z
	double **sagyoL,	 //i H sagyo[][]
	class GA1 *ga0)
{
if(DBGF[30]>1) fprintf(logfp, "idx1(%d)idx2(%d) ", idx1, idx2);
	if( idx1 == idx2 )							CHKA(idx1, idx2, idx1);
	if( idx1 >= ga0->gap.gene_number ) idx1 -= ga0->gap.gene_number;
	else if( idx1 < 0 ) 		  idx1 += ga0->gap.gene_number;
	if( idx2 >= ga0->gap.gene_number ) idx2 -= ga0->gap.gene_number;
	else if( idx2 < 0 ) 		  idx2 += ga0->gap.gene_number;
if(DBGF[30]>1) fprintf(logfp, "sagyoL[%d][%d](%lf)\n", ansL[idx1], ansL[idx2], sagyoL[ansL[idx1]][ansL[idx2]]), fflush(stdout);
	return (idx1 != idx2) ? sagyoL[ansL[idx1]][ansL[idx2]] : 0.0;
}
//for debug
static double get_total(
	int *ansL,
	double **sagyoL,
	class GA1 *ga0)
{
	int 	i;
	double rc = 0.0;
	for ( i = 0; i < ga0->gap.gene_number; i++ ) rc += get_time(i, i+1, ansL, sagyoL, ga0);
	return rc;
}

/*	ID_func1	i Ԗڂ k Ԗڂ̃CfNX
߂l(mode=0) TSP,ATSP : i,k ԖڂOƌ̎ԍ
			   VRP,CVRP ; ̓Kx
	  (mode=1) rc=0
***************************************************************************/
static double  func1(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:邩ۂ̃`FbN, =1:
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL,	//i H sagyo[][]
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	double rc = 0.0, t1, t2, sagyo_max, fitness, route_max = 0.0; // 2015.11.20 YS Add
	int 	w, j;

	if(DBGF[30]>1) fprintf(logfp, "func1:%dԖڂ %d Ԗڂ mode(%d)\n", i, k, mode);
	//ׂvf̂͂߂ func2 œƂ邽
	if( k == i+1 ) {
//		if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) rc = lstsp0->sagyo_maxL;  //???
		if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) rc = lstsp0->fitness;  //KS20151215
		return rc;
	}
		CHKA(i, i+1, k); CHKA(0, i, ga0->gap.gene_number); CHKA(0, k, ga0->gap.gene_number);
	/* ۂɌ */
   if( mode ) {
		if(DBGF[30]>1) {
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "ansL[%d](%d)%s", j, ansL[j], j%10==9?"\n":", "); fprintf(logfp, "\n");
		}
		w = ansL[i]; ansL[i] = ansL[k]; ansL[k] = w;
		if(DBGF[30]>1) {
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "ansL[%d](%d)%s", j, ansL[j], j%10==9?"\n":", "); fprintf(logfp, "\n");
		}
	}
   	/* ̃`FbN */
	else {
	   	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) { // VRP̎
			for( j = 0; j < ga0->gap.gene_number; ++j ) lstsp0->ansW[j] = ansL[j];
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", ansL[j]); fprintf(logfp, "\n");
			}
			//i Ԗڂ k Ԗڂꍇ̍őƎԂ
			w = lstsp0->ansW[i]; lstsp0->ansW[i] = lstsp0->ansW[k]; lstsp0->ansW[k] = w;
//			rc = get_time_VRP( lstsp0->ansW, ga0->gap.gene_number );
			rc = fitness = ga0->bekiFITNES_VRP( lstsp0->ansW, ga0->gap.gene_number, &sagyo_max ,&ga0->gap, &route_max) ; // rout_max̒ǉ 2015.11.20 YS
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\nrc:%lf\n", rc);
			}
		} else {
			//i Ԗڂ k Ԗڂꍇ̍vƎԂ
			if( i == 0 && k == ga0->gap.gene_number-1 ) {
				t1 = get_time(i-1, i, ansL, sagyoL, ga0) + get_time(i, i+1, ansL, sagyoL, ga0) + get_time(k-1, k, ansL, sagyoL, ga0);
				t2 = get_time(i, k, ansL, sagyoL, ga0)	+ get_time(k, i+1, ansL, sagyoL, ga0) + get_time(k-1, i, ansL, sagyoL, ga0);
			} else {
				t1 = get_time(i-1, i, ansL, sagyoL, ga0) + get_time(i, i+1, ansL, sagyoL, ga0) + get_time(k-1, k, ansL, sagyoL, ga0) + get_time(k, k+1, ansL, sagyoL, ga0);
				t2 = get_time(i-1, k, ansL, sagyoL, ga0) + get_time(k, i+1, ansL, sagyoL, ga0) + get_time(k-1, i, ansL, sagyoL, ga0) + get_time(i, k+1, ansL, sagyoL, ga0);
			}
			rc = t1 - t2;
			if(DBGF[30]>1) fprintf(logfp, "t1(%lf)t2(%lf)rc(%lf)\n", t1, t2, rc);
		}
	}
	return rc;
}

/*	ID_func2	k Ԗڂ i Ԗڂ̃CfNX̑Oɑ}
߂l(mode=0) TSP,ATSP : k Ԗڂ i Ԗڂ̑Oɑ}Oƌ̎ԍ
			   VRP,CVRP ; }̓Kx
	  (mode=1) rc=0
***************************************************************************/
static double  func2(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:}邩ۂ̃`FbN, =1:}
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL,	//i H sagyo[][]
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	double rc = 0.0, t1, t2, sagyo_max, fitness, route_max = 0.0; // 2015.11.20 YS Add
	int 	w, n, j;
		 CHKA(0, i, ga0->gap.gene_number);	 CHKA(0, k, ga0->gap.gene_number);
	if(DBGF[30]>1) fprintf(logfp, "func2:%d Ԗڂ %d Ԗڂ̑Oɑ} mode(%d)\n", k, i, mode);
	//k  i Ԗڂ̑OɂƂ́AƓƂȂ̂ł߂
	if( (i == 0 && k == ga0->gap.gene_number-1) || k == i-1) {
		if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) rc = lstsp0->fitness;
		return rc;
	}
	/* ۂɑ} */
	if( mode ) {
		if(DBGF[30]>1) {
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "ansL[%d](%d)%s", j, ansL[j], j%10==9?"\n":", "); fprintf(logfp, "\n");
		}
		if( i < k ) {
			w = ansL[k];
			for( n = k-1; n >= i; --n ) ansL[n+1] = ansL[n];
			ansL[i] = w;
		} else if( i > k ) {
			w = ansL[k];
			for( n = k; n < i-1; ++n ) ansL[n] = ansL[n+1];
			ansL[n] = w;
		}
		if(DBGF[30]>1) {
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "ansL[%d](%d)%s", j, ansL[j], j%10==9?"\n":", "); fprintf(logfp, "\n");
		}
	}
	/* }ŉP邩`FbN */
	else {
	   	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) { // VRP̎
			for( j = 0; j < ga0->gap.gene_number; ++j ) lstsp0->ansW[j] = ansL[j];
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\n");
			}
			// k Ԗڂ i Ԗڂ̑Oɑ}ꍇ̍őƎԂ߂
			if( i < k ) {
				w = lstsp0->ansW[k];
				for( n = k-1; n >= i; --n ) lstsp0->ansW[n+1] = lstsp0->ansW[n];
				lstsp0->ansW[i] = w;
			} else if( i > k ) {
				w = lstsp0->ansW[k];
				for( n = k; n < i-1; ++n ) lstsp0->ansW[n] = lstsp0->ansW[n+1];
				lstsp0->ansW[n] = w;
			}
//			rc = get_time_VRP( lstsp0->ansW, ga0->gap.gene_number );
			rc = fitness = ga0->bekiFITNES_VRP( lstsp0->ansW, ga0->gap.gene_number, &sagyo_max,&ga0->gap , &route_max) ; // rout_max̒ǉ 2015.11.20 YS
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\nrc:%lf\n", rc);
			}
		} else {
			// k Ԗڂ i Ԗڂ̑Oɑ}Oƌ̎ԍ߂
			t1 = get_time(i-1,i, ansL, sagyoL, ga0) + get_time(k-1,k, ansL, sagyoL, ga0) + get_time(k,k+1, ansL, sagyoL, ga0);
			t2 = get_time(i-1,k, ansL, sagyoL, ga0) + get_time(k,i, ansL, sagyoL, ga0) + get_time(k-1,k+1, ansL, sagyoL, ga0);
			rc = t1 - t2;
			if(DBGF[30]>1) fprintf(logfp, "t1(%lf)t2(%lf)rc(%lf)\n", t1, t2, rc);
		}
	}
	return rc;
}

/*	ID_func3a	i Ԗڂ k Ԗڂ܂(i, k ܂)̏tɂ
߂l(mode=0) TSP,ATSP : tɂOƌ̎ԍ
			   VRP,CVRP ; ύX̓Kx
	  (mode=1) rc=0
***************************************************************************/
static double  func3a(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:tɂ邩ۂ̃`FbN, =1:tɂ
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL,	//i H sagyo[][]
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	double rc = 0.0, t1= 0.0, t2 = 0.0, sagyo_max, fitness, route_max = 0.0; // 2015.11.20 YS Add
	int    n, n2, j, w;
				CHKA(0, i, ga0->gap.gene_number); CHKA(0, k, ga0->gap.gene_number);
	if(DBGF[30]>1) fprintf(logfp, "func3a: %d Ԗڂ %d ܂ł̏t mode(%d)\n", i, k, mode);
	if( mode ) {
		if(DBGF[30]>1) {
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "ansL[%d](%d)%s", j, ansL[j], j%10==9?"\n":", ");fprintf(logfp, "\n");
		}
		for( n = i, n2 = k; n <= n2; ++n, --n2 ) {
			w = ansL[n]; ansL[n] = ansL[n2]; ansL[n2] = w;
		}
		if(DBGF[30]>1) {
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "ansL[%d](%d)%s", j, ansL[j], j%10==9?"\n":", ");fprintf(logfp, "\n");
		}
	} else {
	   	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) { // VRP̎
			for( j = 0; j < ga0->gap.gene_number; ++j ) lstsp0->ansW[j] = ansL[j];
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\n");
			}
			//i ` ktɂAőƎԂvZ
			for( n = i, n2 = k; n <= n2; ++n, --n2 ) {
				w = lstsp0->ansW[n]; lstsp0->ansW[n] = lstsp0->ansW[n2]; lstsp0->ansW[n2] = w;
			}
//			rc = get_time_VRP( lstsp0->ansW, ga0->gap.gene_number );
			rc = fitness = ga0->bekiFITNES_VRP( lstsp0->ansW, ga0->gap.gene_number, &sagyo_max ,&ga0->gap , &route_max) ; // rout_max̒ǉ 2015.11.20 YS
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\nrc:%lf\n", rc);
			}
		} else {
			//i ` k ̏vԂvZ
			if( i == 0 && k == ga0->gap.gene_number-1 ) {
				for( n = 0; n <= k; ++n ) t1 += get_time(n, n+1, ansL, sagyoL, ga0);
			} else {
				for( n = i-1; n <= k; ++n ) t1 += get_time(n, n+1, ansL, sagyoL, ga0);
			}
				//tɂꍇvZ
			if( i == 0 && k == ga0->gap.gene_number-1 ) {
				for( n = ga0->gap.gene_number-1; n >= 0; --n ) t2 += get_time(n, n-1, ansL, sagyoL, ga0);
			} else {
				t2 = get_time(i-1, k, ansL, sagyoL, ga0);
				for( n = k; n > i; --n ) t2 += get_time(n, n-1, ansL, sagyoL, ga0);
				t2 += get_time(i, k+1, ansL, sagyoL, ga0);
			}
			rc = t1 - t2;
			if(DBGF[30]>1) fprintf(logfp, "t1(%lf)t2(%lf)rc(%lf)\n", t1, t2, rc);
		}
	}
	return rc;
}
/*	ID_func3b	i Ԗڂ k Ԗڂ܂(i, k ܂), ̊Ȍt
߂l(mode=0) TSP,ATSP : tɂOƌ̎ԍ
			   VRP,CVRP ; ύX̓Kx
	  (mode=1) rc=0
***************************************************************************/
static double  func3b(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:tɂ邩ۂ̃`FbN, =1:tɂ
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL,	//i H sagyo[][]
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	double rc = 0.0, t1 = 0.0, t2 = 0.0, sagyo_max, fitness, route_max = 0.0; // 2015.11.20 YS Add
	int    n, n1, n2, j, dw;
				 CHKA(0, i, ga0->gap.gene_number);	 CHKA(0, k, ga0->gap.gene_number);
	if(DBGF[30]>1) fprintf(logfp, "func3b:%d Ԗڂ %d ܂ł̊Ȍt mode(%d)\n", i, k, mode);
	//O̗vfO܂͂P̂Ƃ
	if( k-i >= ga0->gap.gene_number-2 ) {
		if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) rc = lstsp0->fitness;
		return rc;
	}
	if( mode ) {
		if(DBGF[30]>1) {
			fprintf(logfp, "CO\n");
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%d)%d%s", j, ansL[j], j%10==9?"\n":", "); fprintf(logfp, "\n");
		}
		for( n1 = i-1, n2 = k+1; n1>=0 && n2<ga0->gap.gene_number; --n1, ++n2 ) {
			dw = ansL[n1];	ansL[n1] = ansL[n2];  ansL[n2] = dw;
		}
		if(DBGF[30]>1) fprintf(logfp, "n1(%d)n2(%d)\n", n1, n2);
		if( n1 >= 0 && n2 >= ga0->gap.gene_number ) {
			for( n2 = 0; n1 > n2; ++n2, --n1 ) {
				dw = ansL[n1];	ansL[n1] = ansL[n2];  ansL[n2] = dw;
			}
		} else if( n2 < ga0->gap.gene_number && n1 < 0 ) {
			for( n1 = ga0->gap.gene_number-1; n1 > n2; ++n2, --n1 ) {
				dw = ansL[n1];	ansL[n1] = ansL[n2];  ansL[n2] = dw;
			}
		}
		if(DBGF[30]>1) {
			fprintf(logfp, "C\n");
			for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%d)%d%s", j, ansL[j], j%10==9?"\n":", "); fprintf(logfp, "\n");
		}
	} else {
	   	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) { // VRP̎
			for( j = 0; j < ga0->gap.gene_number; ++j ) lstsp0->ansW[j] = ansL[j];
			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\n");
			}
			//i ` k̊OtɂAőƎԂvZ
			for( n1 = i-1, n2 = k+1; n1>=0 && n2<ga0->gap.gene_number; --n1, ++n2 ) {
				dw = lstsp0->ansW[n1]; lstsp0->ansW[n1] = lstsp0->ansW[n2]; lstsp0->ansW[n2] = dw;
			}
			if(DBGF[30]>1) fprintf(logfp, "n1(%d)n2(%d)\n", n1, n2);
			if( n1 >= 0 && n2 >= ga0->gap.gene_number ) {
				for( n2 = 0; n1 > n2; ++n2, --n1 ) {
					dw = lstsp0->ansW[n1]; lstsp0->ansW[n1] = lstsp0->ansW[n2]; lstsp0->ansW[n2] = dw;
				}
			} else if( n2 < ga0->gap.gene_number && n1 < 0 ) {
				for( n1 = ga0->gap.gene_number-1; n1 > n2; ++n2, --n1 ) {
					dw = lstsp0->ansW[n1]; lstsp0->ansW[n1] = lstsp0->ansW[n2]; lstsp0->ansW[n2] = dw;
				}
			}
//			rc = get_time_VRP( lstsp0->ansW, ga0->gap.gene_number );
			rc = fitness = ga0->bekiFITNES_VRP( lstsp0->ansW, ga0->gap.gene_number, &sagyo_max ,&ga0->gap, &route_max) ; // rout_max̒ǉ 2015.11.20 YS

			if(DBGF[30]>1) {
				for( j = 0; j < ga0->gap.gene_number; ++j ) fprintf(logfp, "%2d ", lstsp0->ansW[j]); fprintf(logfp, "\nrc:%lf\n", rc);
			}
		} else {
			//k+1 ` i-1 ̏vԂvZ
			for( n = k; n < ga0->gap.gene_number + i; ++n ) {
				n2 = (n >= ga0->gap.gene_number) ? n-ga0->gap.gene_number : n;
				t1 += get_time(n2, n2+1, ansL, sagyoL, ga0);
			}
				//tɂꍇ̏vԂvZ
			t2 = get_time(k, i-1, ansL, sagyoL, ga0);
			for( n = i-1+ga0->gap.gene_number; n>k+1; --n ) {
				n2 = (n >= ga0->gap.gene_number) ? n-ga0->gap.gene_number : n;
				t2 += get_time(n2, n2-1, ansL, sagyoL, ga0);
			}
			t2 += get_time(k+1, i, ansL, sagyoL, ga0);
			rc = t1 - t2;
			if(DBGF[30]>1) fprintf(logfp, "t1(%lf)t2(%lf)rc(%lf)\n", t1, t2, rc), fflush(stdout);
		}
	}
	return rc;
}

/*	ID_read_opt	œKt@Cǂ
***************************************************************************/
static int read_opt(		//r:=1:œK@0:œKȂ <0:G[
	char *fname_opt,		//i t@C
	double *sagyo_max2 ,	//o œK
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	FILE * fp = 0;
	int 	rc = 0, i, num, dim, *ans2 = 0, sep_no;
	char buf[256], *poi, *token;
	double fitness2, route_max = 0.0; // 2015.11.20 YS Add

	*sagyo_max2 = 0;
//	if( fname_opt == 0 )	goto					   quit;
	if( fname_opt[0] == '\0' )	  goto				   quit;  //KS130820chg
	if( (fp = fopen(fname_opt,"r")) == 0 )	  goto	   quit;
	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) { // VRP̎
		i = 0;
		if( (ans2 = (int*) malloc(ga0->gap.gene_number*sizeof(*ans2))) == 0 ) { rc = -1; goto	quit; }
		ans2[i++] = 0;	 // ̧قɂOȂ@opt̃t@C͂On܂łON_̂悤
		sep_no = ga0->gap.gene_number - ga0->gap.allele_number +1 ;
		while(fgets(buf, 256, fp) != 0) {
			if( strstr(buf, "Route") == 0 ) continue;  //KS130820add Route ȊO̕Ɛ䂪ĈُI
			token=strtok(buf, "\t\n\r " ); // Route #1:ǂݔ΂
			token=strtok(NULL, "\t\n\r " );
			token=strtok(NULL, "\t\n\r " );
			while( token != NULL ) {
				num = atoi(token);
				if( num <= 0 || num >= ga0->gap.gene_number )  goto quit;
				ans2[i++] = num ;
				if( i >= ga0->gap.gene_number)	  break;
				token=strtok(NULL, "\t\n\r " );
			}
			if( i >= ga0->gap.gene_number)	  break;
			ans2[i++] = sep_no++;
		}
		if( i != ga0->gap.gene_number )	 goto quit;
		//őƎԂƓKx߂
		fitness2 = ga0->bekiFITNES_VRP( ans2, ga0->gap.gene_number, sagyo_max2 ,&ga0->gap , &route_max) ; // rout_max̒ǉ 2015.11.20 YS
		// VRPt@C̉𓚂́Âlsrỏ𓚂ɂ͕sK؂̂߁AOԂ悤ɏC
		// VRP̉𓚂́AN_܂Ŗ߂HĂ邪Alsro͋N_lĂȂ
		//rc = 0;
		rc = 1;   // t@C̒lŋ߂sagyo_max gĂ݂@2013.09.02 YS
	} else {
		// F̐
		while(fgets(buf, 256, fp) != 0) {
			if( strstr(buf,"DIMENSION") != 0 ) {
				if((poi = strchr(buf,':')) == 0 )	 goto quit;
				dim = atoi(poi+1);
			if( dim != ga0->gap.gene_number )  goto quit;
			}
			if( strstr(buf,"TOUR_SECTION") != 0 ) break;
		}
		// œKipXj̓ǂݍ
		i = 0;
		if( (ans2 = (int*) malloc(ga0->gap.gene_number*sizeof(*ans2))) == 0 )  { rc = -1; goto	 quit; }
//	for( k = 0; k < ga0->gap.gene_number; ++k ) ans2[k] = -1;
		while(fgets(buf, 256, fp) != 0) {
			if( buf[0] == '\0' || buf[0] == '\n' ) continue;//KS130821add sǂݔ΂
//Psɉ̒lPo^ĂƂ͌Ȃ /TSPLIB/gr48.opt.tour, rd100.opt.tour Q KS130827chg
//			num = atoi(buf);
//			if( num <= 0 || num > ga0->gap.gene_number ) { CHKB(1, num, ga0->gap.gene_number); goto quit; }  //KS130821 CHKBǉ
//			ans2[i++] = num -1 ;  // On܂ɕϊ
//			if( i >= ga0->gap.gene_number)	 break;
			token = strtok(buf, "\t\n\r " );
			while( token != NULL ) {
				num = atoi(token);
				if( num <= 0 )  break;                   //Ō -1 ̒l̂ŔÔ
				if( num > ga0->gap.gene_number )  goto quit; //G[
			ans2[i++] = num -1 ;  // On܂ɕϊ
			if( i >= ga0->gap.gene_number)	 break;
				token = strtok(NULL, "\t\n\r " );
			}
			if( i >= ga0->gap.gene_number)	 break;
		}
		if( i != ga0->gap.gene_number ) { CHKB(ga0->gap.gene_number, i, ga0->gap.gene_number); goto quit; }  //KS130821 CHKBǉ
		//vƎԂƓKx߂
		fitness2 = ga0->bekiFITNES( ans2, ga0->gap.gene_number, sagyo_max2 ,&ga0->gap );
		rc = 1;
	}
quit:			CHKB(0, rc, rc);  //KS130918 CHK ǉ
	if( ans2 != 0 ) free(ans2);
	if( fp != 0 ) fclose(fp), fp = 0;
	return rc;
}

/*	ID_lstspV0	CfNX̌AבւāAŏ̍őƎԂ(VRPpj
***************************************************************************/
static int	lstspV0(
	double sagyo_max,	 //i őƎ
	int    *ansL,		  //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	  //i H sagyo[][]
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	int    k, i, endf, n, cnt, rc, j;
	double tw;

	lstsp0->sagyo_maxL = sagyo_max;
	if( (lstsp0->ansW = (int*)malloc(ga0->gap.gene_number*sizeof(int))) == 0 ) { rc = -1; goto		quit; }
	for( cnt = endf = 0; endf == 0 ; ) {
		endf = 1;
		for( i = 0; i < ga0->gap.gene_number; i++ ) {
			for( k = ga0->gap.gene_number - 1; k >= i+1 ; --k ) {
				if(DBGF[30]>1) fprintf(logfp, "i(%d)k(%d)\n", i, k);
				n = -1;
				tw = func1(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw > lstsp0->fitness ) { n = 1; lstsp0->fitness = tw; }
				tw = func2(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw > lstsp0->fitness ) { n = 2; lstsp0->fitness = tw; }
				tw = func2(k, i, 0, ansL, sagyoL, ga0, lstsp0); if( tw > lstsp0->fitness ) { n = 3; lstsp0->fitness = tw; }
				tw = func3a(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw > lstsp0->fitness ) { n = 4; lstsp0->fitness = tw; }
				tw = func3b(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw > lstsp0->fitness ) { n = 5; lstsp0->fitness = tw; }
				if( n == 1 )	  func1(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 2 ) func2(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 3 ) func2(k, i, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 4 ) func3a(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 5 ) func3b(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				if( n > 0 )
					endf = 0;
				if( n > 0 && DBGF[30]>1)
					fprintf(logfp, "n(%d)lstsp0->sagyo_maxL(%lf)i(%d)k(%d)\n", n, lstsp0->sagyo_maxL, i, k);
				//CHKAD(100.0,lstsp0->fitness ,3000.0); // IMADAKE
			}
		}
//		if( endf == 0 ) CHKAD(0.0, 0.0, delta);
		++cnt;
	}
	if(DBGF[30]>1) {
		if( lstsp0->sagyo_maxL < sagyo_max ) {
			fprintf(logfp, "C ansL=(");
			for ( j=0 ; j<ga0->gap.gene_number ;j++ ) fprintf(logfp, "%d ",ansL[j]);
			fprintf(logfp, ")\nsagyo_max(%lf)\n",lstsp0->sagyo_maxL);
		}
	}
	if(DBGF[30]>1) fprintf(logfp, "[v(%d)\n", cnt), fflush(stdout);
	rc = cnt;
quit:			CHKB(0, rc, rc);  //KS130918 CHK ǉ
	if( lstsp0->ansW != 0 ) free(lstsp0->ansW);
	return( rc );
}

/*	ID_lstsp_go0	CfNX̌AבւāAœKށisro̎j
***************************************************************************/
static int lstsp_go0(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	 //i H sagyo[][]
	class GA1 *ga0,
	class LSTSP *lstsp0)
{
	int 	k, i, n, endf, cnt;
	double tw, delta = 0.0, eps = 1e-6;

	for( cnt = endf = 0; endf == 0 ; ) {
		endf = 1;
		for( i = 0; i < ga0->gap.gene_number; i++ ) {
			for( k = ga0->gap.gene_number - 1; k >= i+1 ; --k ) {
				if(DBGF[30]>1) fprintf(logfp, "i(%d)k(%d)\n", i, k);
				n = -1;
				delta = 0.0;
				tw = func1(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw-eps > delta ) { n = 1; delta = tw; }
				tw = func2(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw-eps > delta ) { n = 2; delta = tw; }
				tw = func2(k, i, 0, ansL, sagyoL, ga0, lstsp0); if( tw-eps > delta ) { n = 3; delta = tw; }
				tw = func3a(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw-eps > delta ) { n = 4; delta = tw; }
				tw = func3b(i, k, 0, ansL, sagyoL, ga0, lstsp0); if( tw-eps > delta ) { n = 5; delta = tw; }
				if( n == 1 )	  func1(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 2 ) func2(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 3 ) func2(k, i, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 4 ) func3a(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				else if( n == 5 ) func3b(i, k, 1, ansL, sagyoL, ga0, lstsp0);
				if( n > 0 ) endf = 0;
				if( n > 0 && DBGF[30]>1)
					fprintf(logfp, "n(%d)delta(%lf)total(%lf)\n", n, delta, get_total(ansL, sagyoL, ga0));
			}
		}
//KS130827del		if( endf == 0 ) CHKAD(0.0, 0.0, delta);
		++cnt;
	}
	if(DBGF[30]>1) fprintf(logfp, "[v(%d)\n", cnt), fflush(stdout);
	return( cnt );
}

/*	ID_lstsp	CfNX̌AבւāAœK
***************************************************************************/
int  lstsp_go(			   //=1:œKt@C@=0:œKt@C
	struct gaparm	*gparm,
	int 	algotype,
	double	*def_num,
	class LSTSP *lstsp0,
	class GA1 *ga0,
	double *lval)
{
	int    j, rtc, rc_opt, rc = 0;
	double sagyo_max2, fitness = 0, route_max = 0.0; // 2015.11.20 YS Add
	int   *ansL = 0;			 //ans[gene_number]
	double **sagyoL;		 //sagyo[gene_number] [gene_number]

//	gap = *gparm;
	sagyoL = ga0->sagyo;
	ansL = ga0->ans;
	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) { // VRP̎
		if( (lstsp0->route_numL = (double*) malloc(ga0->gap.allele_number*sizeof(*lstsp0->route_numL))) == 0 ) {rc = -1; goto  quit; }
		for ( j=0 ; j<ga0->gap.allele_number ;j++ ) lstsp0->route_numL[j] = 0.0;
		//œKt@Cǂ
		if( (rc_opt = read_opt(ga0->gap.optsol_fname, &sagyo_max2, ga0, lstsp0)) < 0 )	{ rc = -1; goto					quit; };
		// VRP̂nost@Čʂdef_numoĂӖȂ̂ŁAʂłlval̂ݏo͂Ă@āArc_opt=0ɂȂċAĂ
		// sagyo_max2ӖA[go͂̂ŁAbekiFITNES_VRP()͓I
		// @vCIIIII@QOPRDOWDROxr
//		if( rc_opt == 1 )  sagyo_max2 /= 2.0;
		//sagyo_max2 /= 2.0;	 //KS130820chg	vrp ̏ꍇ͏ɁArc_opt = 0 ƂȂ邽 <= ӖȂIxr
		// sagyo_max2QŊKv͂Ȃ͂ 2013.09.02 YS
		if( rc_opt == 0 ) { // t@CƂ́AoptimalValueg 2013.09.02 YS
			// optimalValuéAe[gN_܂Ŗ߂̑v̋Ȃ̂ŁAQDOŊċ߂lɂĂB
			sagyo_max2 = ga0->optimalValue / 2.0;  
		}
		if(DBGF[30]>1) {
			fprintf(logfp, "CO ansL=(");
			for ( j=0 ; j<ga0->gap.gene_number ;j++ ) fprintf(logfp, "%d ",ansL[j]);
			fprintf(logfp, ")\nlstsp0->sagyo_max(%lf)\n",lstsp0->sagyo_max);
		}
		if( lstspV0(lstsp0->sagyo_max, ansL, sagyoL, ga0, lstsp0) < 0 ) { rc = -1; goto					quit; };
		//vƎԂ̌vZ
		fitness = ga0->bekiFITNES_VRP( ansL, ga0->gap.gene_number, &lstsp0->sagyo_max, &ga0->gap , &route_max) ; // rout_max̒ǉ 2015.11.20 YS

		if(DBGF[30]) {
			fprintf(logfp, "ansL=(");
			for ( j=0 ; j<ga0->gap.gene_number ;j++ ) fprintf(logfp, "%d ",ansL[j]);
			fprintf(logfp, ")\nsagyo_max(%lf)fitness(%lf)\n",lstsp0->sagyo_max, fitness);
		}
		/* _ʂĂȂ̃`FbN */
		chk_same_point_tsp(ansL, ga0->gap.gene_number, ga0->chk );
		// VRP̎Asagyo_max2̓t@C̒lłȂAkr̉@lstsp0->sagyo_maxɂ́AGǍʂĂ͂Ȃ̂rc_optɊ֌WȂ̌vZĂ
		//if( rc_opt == 0 ) *def_num = (lstsp0->sagyo_max - sagyo_max2) / sagyo_max2 * 100;
		//					CHKAD(0.0, 0.0, sagyo_max2);  //KS130820add t@CȂ sagyo_max2=0 ȉ̌vZ͂ON
		*def_num = (lstsp0->sagyo_max - sagyo_max2) / sagyo_max2 * 100;
		*def_num = 0.0;   // ӖȂ̂łOԂ
		//*lval = lstsp0->route_max;
		*lval = lstsp0->sagyo_max;   // [gőlł͂ȂASHԂ
//		for(i = 0; i < ga0->gap.gene_number; ++i) ansG[i] = ansL[i];
	} else {													//TSP
//eXgp CfNX̏
//for( k = ga0->gap.gene_number - 1, i = 0; i < ga0->gap.gene_number; i++, k-- ) ansL[i] = k;
//for( i = 0; i < ga0->gap.gene_number; i++ ) ansL[i] = i;

		if(DBGF[30]) {
			fprintf(logfp, "ansL=(");
			for ( j=0 ; j<ga0->gap.gene_number ;j++ ) fprintf(logfp, "%d ",ansL[j]);
			fprintf(logfp, ")\ntotal_init(%lf)\n", get_total(ansL, sagyoL, ga0));
			fprintf(logfp, "\n");
		}
		//œKt@Cǂ
		if( (rc_opt = read_opt(ga0->gap.optsol_fname, &sagyo_max2, ga0,  lstsp0)) < 0 ) { rc = -1; goto					quit; };
		rtc = lstsp_go0( ansL, sagyoL, ga0, lstsp0);
		//vƎԂ̌vZ
		fitness = ga0->bekiFITNES( ansL, ga0->gap.gene_number, &lstsp0->sagyo_max,&ga0->gap );
		/* _ʂĂȂ̃`FbN */
		chk_same_point_tsp(ansL, ga0->gap.gene_number, ga0->chk );

		if( rc_opt == 1 ) *def_num = (lstsp0->sagyo_max - sagyo_max2) / sagyo_max2 * 100;
		else *def_num = lstsp0->sagyo_max;	// opţقȂȂAS[gԂB
		*lval = lstsp0->sagyo_max;
	}
	lstsp0->fitness = fitness;   // 2015.11.27 Y.S Add csvւ̓tBbglXŏo
	if(DBGF[30]) {
		fprintf(logfp, "ansL=(");
		for ( j=0 ; j<ga0->gap.gene_number ;j++ ) fprintf(logfp, "%d ",ansL[j]);
		fprintf(logfp, ")\nsagyo_max(%lf)fitness(%lf)sagyo_max2(%lf)\n",lstsp0->sagyo_max, fitness, sagyo_max2);
	}
	//*lval = lstsp0->sagyo_max;
	rc = rc_opt;  //KS130904add TSP ŁAœKt@C݂̑ꍇAcsv t@C֍قo͂
quit:			CHKB(0, rc, rc);  //KS130918 CHK ǉ
	if( lstsp0->route_numL != 0 ) free(lstsp0->route_numL), lstsp0->route_numL = 0;
if(DBGF[30]) fprintf(logfp, "%d	%lf	%lf\n", rc, fitness, *def_num);
//*fitnessL = fitness;
//fprintf(logfp, "sagyo_max(%lf)fitness(%lf)sagyo_max2(%lf)def_num(%lf)\n", sagyo_max, fitness, sagyo_max2, *def_num);
	return( rc );
}
