/*
 * file		: lstsp.h
 * system	: TSP&GA
 * function	: TSP֘Awb_[
 * auther	: 2013.04.22 Y.Shibasaki
 */
#ifndef LSTSP_h
#define LSTSP_h

class LSTSP {
public:
	double sagyo_maxL;
	int   *ansW;             //[NGA
	double *route_numL;    // VRP e[gƂ̍v
	double	route_max;		// VRP S[g̍ől 130617 YS
	double	sagyo_max;		// VRP S[g̍v 130617 YS
	double	fitness;		// VRP Kx 130617 YS
	// ftHgRXgN^.
	LSTSP(){ ansW = 0; route_numL = 0;}
};  // class end

int lstsp_go(			   //r:=1œK. =0:Ȃ
	struct gaparm	*gparm,
	int 	algotype,
	double	*def_num,
	class LSTSP *lstsp0,
	class GA1 *ga0,
	double	*lval);

#ifdef Z0
double lsFunc(
	struct gaparm	*gparm, /*i gaOption*/
	int 	algotype,		/*u (gp) */
	int 	argc,			/*u (gp) */
	char	**argv, 		/*u (gp) */
	int 	argcend,		/*u (gp) */
	double sagyo_max,		//gatsp ŋ߂ꂽ(tsp:SH, vrp:őƎ)
	double *def_num,		/*o œKƂ̍ */
	class GA1 *ga0,
	class GA1 *ga0);
double lstsp(			   //r:œK. =0:G[
	struct	gaparm *gparm, /*gaOption*/
	int    *ansG,			//i sagyo[][]̃CfNXi[z
	double	**sagyoG,		//i H sagyo[][]
	char	*fname_opt,    //i œKt@C
	double	sagyo_max,
	double	*def_num,		//o œKƂ̍
	double	*fitnessL);		 //fobNp@Ƃŏ

double lsFunc(
	struct gaparm	*gparm, /*i gaOption*/
	int 	algotype,		/*u (gp) */
	int 	argc,			/*u (gp) */
	char	**argv, 		/*u (gp) */
	int 	argcend,		/*u (gp) */
	double sagyo_max,		//gatsp ŋ߂ꂽ(tsp:SH, vrp:őƎ)
	double *def_num);		/*o œKƂ̍ */

double get_time(
	int idx1,			 //i ans[] ̃CfNX
	int idx2,			 //i ans[] ̃CfNX
	int *ansL,			 //i sagyo[][]̃CfNXi[z
	double **sagyoL);	 //i H sagyo[][]


double get_total(int *ansL, double **sagyoL);

double func1(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:邩ۂ̃`FbN, =1:
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL);	//i H sagyo[][]

double func2(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:}邩ۂ̃`FbN, =1:}
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL);	//i H sagyo[][]

double func3a(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:tɂ邩ۂ̃`FbN, =1:tɂ
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL);	//i H sagyo[][]

double func3b(
	int i, int k,		//i ans[] ̃CfNX
	int mode,			//i =0:tɂ邩ۂ̃`FbN, =1:tɂ
	int *ansL,			//i sagyo[][]̃CfNXi[z
	double **sagyoL);	//i H sagyo[][]

int read_opt(		//r:=0: <0:G[
	char *fname_opt,		//i t@C
	double *sagyo_max2 );	//o œK

int lstspV0(
	double sagyo_max,	 //i őƎ
	int    *ansL,		  //i sagyo[][]̃CfNXi[z
	double	**sagyoL);	  //i H sagyo[][]

int lstsp0(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL);	 //i H sagyo[][]

int lstsp1(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	 //i H sagyo[][]
	int 	*endf2); 	 //io C`FbNtO(=1:CȂ, =0:C)

int lstsp2a(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	 //i H sagyo[][]
	int 	*endf2); 	 //io C`FbNtO(=1:CȂ, =0:C)

int lstsp2b(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	 //i H sagyo[][]
	int 	*endf2); 	 //io C`FbNtO(=1:CȂ, =0:C)

int lstsp3a(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	 //i H sagyo[][]
	int 	*endf2); 	 //io C`FbNtO(=1:CȂ, =0:C)

int lstsp3b(
	int 	*ansL,		 //i sagyo[][]̃CfNXi[z
	double	**sagyoL,	 //i H sagyo[][]
	int 	*endf2); 	 //io C`FbNtO(=1:CȂ, =0:C)


#endif

#endif // LSTSP_h
