// TSP_GA.cpp : R\[ AvP[ṼGg |Cg`܂B
//
/*
 * file     : ga1main.c
 * system   : `ASYga1()̃eXgpC
 * function : 킍@Bmake span problem̗
 * auther   : 1994/01/14 s.kobayashi
 */
//#include  <stdafx.h>
#pragma warning(disable:4996)
#include    <stdio.h>
#include    <stdlib.h>
#include    <malloc.h>
#include    <string.h>
#include    <time.h>
#include <math.h>
#define MAIN
#include    "ssc.h"
#include    "gaparm.h"
//#include  "gatsp.h"
#include    "ga1.h"
#include    "lstsp.h"

#define DEF_loop     100    /* 㐔 */
#define DEF_p_size    20    /* ̐ */
#define DEF_n_job     80    /* Wu 98/06*/
#define DEF_n_mcn      4    /* @B 98/06*/  // 2019.12.02 N.T ߂Ă
//#define DEF_n_mcn    1    /* @B 98/06*/  // 2016.01.05 Y.S ftHgPɂĂ݂
static char dbgf[100];
int eda_no = -1;   // ʏo͗p}

/*  ID_gaMTSP   
********************************************************************/
int gaMTSP( class GA1 *ga0);

static struct gaparm init_gap = {
    /* int    popul_size */     DEF_p_size,     // ̐ 20
    /* int    gene_number */    DEF_n_job,      // Wui`qj 80
    /* int    allele_number */  DEF_n_mcn,      // @BiΗ`qj 4
    /* int    locus_unique */   1,              //  1 `qƂɂƂ肤`qقȂ
    /* int    selec_type */     SELEC_TYPE_HOPE,// eo@@Ғl
    /* double cross_rate */     1.0,            // 
    /* int    cross_type */     0,              // ڰ@0:Ȃ
    /* int    cross_count */    2,              // >1:_
    /* double mutat_rate */     0.01,           // ˑRψٗ
    /* int    mutat_typ */      0,              // ˑRψٵڰ 0:Ȃ
    /* int    elite_prsv */     ELITE_PRSV_ON,  // 1:G[gۑ
    /* int    with_repla */     WITH_REPLA_ON,  // 1:o
    /* int    sharing    */     SHARING_ON,     // 1:̂P̌̂Ƃ݂Ȃ
    /* int    gener_gap  */     DEF_p_size,     // Mbv 20
    /* int    loop       */     DEF_loop,       // 㐔 100
    /* double *rank      */     NULL,           // N
    /* int    problem_type*/    0,              // ^Cv@1:TSP 2:ATSP 3:VRP 4: CVRP 13/02/25 YS
    /* char   *dbgf      */     dbgf,           // g[XtO
};

/*  ID_DBGF_init_size   DBGF_init̃TCY擾
********************************************************************/
int DBGF_init_size()
{
    int nn;
    //nn = sizeof(*DBGF_init) / sizeof(DBGF_init[0]);  //NT130821 _
    nn = sizeof(DBGF_init) / sizeof(DBGF_init[0]); 
    return(nn);
}
/*  ID_DBGF_size    DBGF̃TCY擾
********************************************************************/
int DBGF_size()
{
    int nn;
    //nn = sizeof(*DBGF) / sizeof(DBGF[0]);  //NT130821 _
    nn = sizeof(DBGF) / sizeof(DBGF[0]); 
    return(nn);
}
/*  ID_*base_name   pXăt@C擾
********************************************************************/
static char *base_name( char *s )
//  char    *s;
{
    char    *t;
    for( t = s; *s; ++s ) if( *s == '/' || *s == '\\' ) t = s + 1;
    return t;
}
#if 0 // ݓȂ@\邽ߕύX
/*  ID_Usage    
********************************************************************/
static int Usage(
    char    *pgname)
{
//  printf( "Usage: %s {g|h} [r|k|h] [`ASYҰ̧]\n", base_name(pgname) ); NT121205
    printf( "Usage:\n");
    printf( "%s g {r|k|h} [`ASYҰ̧ [TSPLIB̧ [TSPLIBoptsoļ]]]\n", base_name(pgname) );
    printf( "%s h         [`ASYҰ̧]\n", base_name(pgname) );
    printf( "    g: `ASYɂvZ\n" );
    printf( "    h: q[XeBbNɂvZ\n" );
    printf( "    r: g̎[bg헪\n" );
    printf( "    k: g̎N헪\n" );
    printf( "    h: g̎Ғl헪\n" );
    printf( "    `ASYҰ̧ : ȗANިڸ؂ga1_def.txtQƂ\n" ) ;
    printf( "p[^`t@Ciga1_def.txtjĂB\n" );
    printf( "TSPLIBt@Cw肷Ƃ́A`ASYҰ̧ٖĂB\n" );
    return(-1);
}
#endif
/*  ID_Usage    ̓e
********************************************************************/
static int Usage(
    char    *pgname)
{
    printf( "Usage:\n");
    printf( "%s TSPLIB̧ٖ@ [TSPLIBoptsoļٖ]\n", base_name(pgname) );
    printf( "p[^`t@Ciga1_def.txtjNިڸ؂ɕK{łB\n" );
    printf( "TSPLIBt@CсATSPLIBoptsoļق́AQlɍ쐬ĂB\n" );
    return(-1);
}
/*  ID_Help_def_file    p[^t@C̓e
********************************************************************/
static int Help_def_file()
{
    printf( "#  `ASỸp[^t@C\n" );
    printf( "#Ŏn܂s̓RgsłB\n" );
    printf( "#  p̑啶Ə͋ʂ܂B\n" );
    printf( "#  gener_gap͐sq̐łPȏpopul_sizeȉB\n");
    printf( "#           ͈͊ÔƂpopul_sizeƂ݂ȂB\n");
    printf( "#  񕜌oƃVFAO͓ɂ͎wł܂B\n" );
    printf( "popul_size nnn          ̐ \n");
    printf( "gene_number nnn         F̂̈`q̌ ijob)\n");
    printf( "allele_number nnn       e`q蓾قȂľ(@B)\n");
    printf( "locus_unique {ON|OFF}   `qƂɂƂ肤`qقȂB" ) ;
    printf( "selec_type {n|1|RAND|2|RANK|3|HOPE} 1:[bg 2:N 3:Ғl\n");
    printf( "cross_rate n.nnn        \n");
//  printf( "cross_type {0|1|2|3|4|5|6|7|8}} װ 0:m[} 1:^ 2:ʒu^@3:ʑ^ 4:z^ 5:TucA[^ 6:Ӎđg^ 7:ݕӌ^ 8:oH^\n") ; KS130827chg
    printf( "cross_type {0|1|2|3|4|5|6|7|8|9} װ 0:m[} 1:^ 2:ʒu^@3:ʑ^ 4:z^ 5:TucA[^ 6:Ӎđg^ 7:ݕӌ^ 8:oH^ 9:SCX\n") ;
    printf( "cross_count {0|OFF|-1|ALL|nn} 0: 1:P >1:_ -1:l\n");
    printf( "mutat_rate n.nnn        ˑRψٗ\n");
//  printf( "mutat_type {0|1|2}      ˑRψٵڰ 0:m[} 1:^ 2:}^ 3:2OPT^\n" ) ; KS130827chg
    printf( "mutat_type {0|1|2|3}    ˑRψٵڰ 0:m[} 1:^ 2:}^ 3:2OPT^\n" ) ;
    printf( "elite_prsv {0|OFF|1|ON} 0:G[gۑȂ 1:ۑ\n");
    printf( "with_repla {0|OFF|1|ON} 0:oȂ 1:o\n");
    printf( "sharing    {0|OFF|1|ON} 0:̂ʂđI 1:P̌̂Ƃ݂Ȃ\n");
    printf( "gener_gap  nnn          Mbv\n");
    printf( "loop       nnn          ΐ\n");
    printf( "trace      fff...       g[XtOA\n");
    return(0);
}
#pragma warning(disable:4996)
/*  ID_argparm  At@CA𓚃t@C擾
********************************************************************/
static int argparm( //argc, argv, algotype, selec_typ, fname ) /*returnl͍ς݂argv[]̔zԍ*/
int     argc       , //i
char    **argv     , //i
int     *algotype  , //o
int     *selec_typ , //o
char    *fname     , //o
char    *pfname    , //o t@C 13.04.26 YS
char    *sfname    ) //o 𓚃t@C 13.04.26 YS
{
    int rc=0 ;
    /*h*/
    /*g [r/k/h]*/
    *algotype  = 0;  // ݂OFf`̂ݗL
    *selec_typ = SELEC_TYPE_RAND;  // p[^̃Zbg͎~߁At@C̒lɂ@lFSELEC_TYPE_RAND 1   /* [bg */
    *fname = '\0' ;  // p[^t@Ĉ̖́Aga1_def.txtɌŒ
    *pfname = '\0' ;
    *sfname = '\0' ;
    if ( argc < 2 ) { rc = Usage( argv[0] ) ;
    } else {
        /* t@CȂA̖OԂ*/
        if ( argc > rc + 1 && (*argv[rc+1] < '0' || *argv[rc+1] > '9' )) strcpy( pfname, argv[++rc] ) ;
        /* 𓚃t@CȂA̖OԂ*/
        if ( argc > rc + 1 && (*argv[rc+1] < '0' || *argv[rc+1] > '9' )) strcpy( sfname, argv[++rc] ) ;
    }
    return(rc);
}
/*  ID_RTrim     bpstrHitƂ̑OSpaceȍ~폜
********************************************************************/
char *RTrim( char *bp, char *strHit )
{
    char *cp = bp ;
    char *s1, *s2 ;
    if ( ! *strHit )  goto                                      DSpace ;
    while ( *cp ) {
        s1 = cp;
        s2 = strHit ;
        while ( *s1 && *s2 && !( *s1 - *s2 ) ) s1++, s2++;
        if ( !*s2 ) { *cp = '\0' ; break ; }
        cp++;
    }
DSpace :
    while ( *cp++ ) ;
    while ( *--cp == ' ' ) ;
    *++cp = '\0' ;
  return( bp ) ;
}

/*  ID_Get_default  p[^t@Cǂ݁AftHglݒ
********************************************************************/
static int Get_default(// fname, gap0, algotype )
    char    *fname,
    struct gaparm *gap0,
    int     *algotype )  // gp
{
    FILE    *fp = NULL;
    int     rc, i;
    char    bf[256], *bp, key1[64], key2[64];

    if( (fp=fopen(fname, "r")) == NULL ) goto                  err;
    while( bp=fgets(bf, 256, fp) ) {
        if( bp[0] == '#' || bp[0] == '\n' ) continue;
        bp = RTrim( bp, "#" ) ;             /* #ȍ~폜*/
        for( i = 0 ; bp[i] ; ++i )
            if( bp[i] >= 'a' && bp[i] <= 'z' ) bp[i] += 'A' - 'a'; // 啶ɕϊ
        rc = sscanf( bp, "%s %s", key1, key2 );    CHKB(2,rc,2);
        if( rc <= 1 ) { continue;
        } else if ( strncmp(key1, "POPUL_SIZE", 10 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->popul_size ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if ( strncmp(key1, "GENE_NUMBER", 11 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->gene_number ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if ( strncmp(key1, "ALLELE_NUMBER", 13 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->allele_number ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if ( strncmp(key1, "LOCUS_UNIQUE", 12 ) == 0 ) {
            if( strncmp( key2, "ON", 2 ) == 0 )
                gap0->locus_unique = 1 ;
        } else if( strncmp(key1, "SELEC_TYPE", 10 ) == 0 ) {
            if( strncmp( key2, "RAND", 4 ) == 0 )
                gap0->selec_type = SELEC_TYPE_RAND;
            else if( strncmp( key2, "RANK", 4 ) == 0 )
                gap0->selec_type = SELEC_TYPE_RANK;
            else if( strncmp( key2, "HOPE", 4 ) == 0 )
                gap0->selec_type = SELEC_TYPE_HOPE;
            else {
                rc=sscanf(key2, "%d", &gap0->selec_type ), CHKB(1,rc,1);
                if( rc < 1 ) goto                              usage;
            }
        } else if( strncmp(key1, "CROSS_RATE", 10 ) == 0 ) {
            rc=sscanf(key2, "%lf", &gap0->cross_rate ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if ( strncmp(key1, "CROSS_TYP", 9 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->cross_typ ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if( strncmp(key1, "CROSS_COUNT", 11 ) == 0 ) {
            if( strncmp( key2, "OFF", 3 ) == 0 )
                gap0->cross_count = CROSS_COUNT_OFF;
            else if( strncmp( key2, "ALL", 3 ) == 0 )
                gap0->cross_count = CROSS_COUNT_ALL;
            else {
                rc=sscanf(key2, "%d", &gap0->cross_count ), CHKB(1,rc,1);
                if( rc < 1 ) goto                              usage;
            }
        } else if ( strncmp(key1, "MUTAT_TYP", 9 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->mutat_typ ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if( strncmp(key1, "MUTAT_RATE", 10 ) == 0 ) {
            rc=sscanf(key2, "%lf", &gap0->mutat_rate ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if( strncmp(key1, "ELITE_PRSV", 10 ) == 0 ) {
            if( strncmp( key2, "ON", 2 ) == 0 )
                gap0->elite_prsv = ELITE_PRSV_ON;
            else if( strncmp( key2, "OFF", 3 ) == 0 )
                gap0->elite_prsv = ELITE_PRSV_OFF;
            else {
                rc=sscanf(key2, "%d", &gap0->elite_prsv ), CHKB(1,rc,1);
                if( rc < 1 ) goto                              usage;
            }
        } else if( strncmp(key1, "WITH_REPLA", 10 ) == 0 ) {
            if( strncmp( key2, "ON", 2 ) == 0 )
                gap0->with_repla = WITH_REPLA_ON;
            else if( strncmp( key2, "OFF", 3 ) == 0 )
                gap0->with_repla = WITH_REPLA_OFF;
            else {
                rc=sscanf(key2, "%d", &gap0->with_repla ), CHKB(1,rc,1);
                if( rc < 1 ) goto                              usage;
            }
        } else if( strncmp(key1, "SHARING", 7 ) == 0 ) {
            if( strncmp( key2, "ON", 2 ) == 0 )
                gap0->sharing = SHARING_ON;
            else if( strncmp( key2, "OFF", 3 ) == 0 )
                gap0->sharing = SHARING_OFF;
            else {
                rc=sscanf(key2, "%d", &gap0->sharing ), CHKB(1,rc,1);
                if( rc < 1 ) goto                              usage;
            }
        } else if( strncmp(key1, "GENER_GAP", 9 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->gener_gap ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if ( strncmp(key1, "LOOP", 4 ) == 0 ) {
            rc=sscanf(key2, "%d", &gap0->loop ), CHKB(1,rc,1);
            if( rc < 1 ) goto                                  usage;
        } else if ( strncmp(key1, "TRACE", 5 ) == 0 ) {
            strcpy( gap0->trace, key2 );
            if( rc < 1 ) goto                                  usage;
        } else {
            printf("**** ga1main : invalid key in %s (%s)\n", fname, key1 );
            goto                                               usage;
        }
    }
    if ( gap0->cross_typ ) gap0->locus_unique = 1 ; /* ʌ^Aʒu^̎locus_unique=1 */
    rc = 0;
quit:
    if( fp != NULL )    fclose(fp);
    return( rc );
err:
    rc = 0;
    printf( "*** WARNING ̧(%s)݂܂BDefaultlZbg܂B\n", fname );
    goto                                                       quit;
usage:
    Help_def_file();
    rc = -1;
    goto                                                       quit;
}
//static int Gap_print( gap0 )   // gatsp.cgp
/*  ID_Gap_print    p[^t@C̓eAʃt@C֏o
********************************************************************/
int Gap_print(
    FILE    *fp,
    struct gaparm   *gap0)
{
    fprintf(fp, "popul(%d)", gap0->popul_size );
    fprintf(fp, "selec(%d:", gap0->selec_type );
    if( gap0->selec_type == 1 ) fprintf(fp, "[bg" );
    if( gap0->selec_type == 2 ) fprintf(fp, "N" );
    if( gap0->selec_type == 3 ) fprintf(fp, "Ғl" );
    fprintf(fp,")\n") ;
    if ( gap0->locus_unique ) fprintf(fp,"`qƂɂƂ肤`q̒lقȂB\n") ;
    else                                            fprintf(fp,"`q̒l͏dB\n") ;

    fprintf(fp, "ڰ݁F" ) ;
    switch ( gap0->cross_typ ) {
    case 0 : fprintf(fp, "0:NORMAL\n" ) ; break ;
    case 1 : fprintf(fp, "1:^\n" ) ; break ;
    case 2 : fprintf(fp, "2:ʒu^\n" ) ; break ;
    case 3 : fprintf(fp, "3:ʑ^\n" ) ; break ;
    case 4 : fprintf(fp, "4:z^\n" ) ; break ;
    case 5 : fprintf(fp, "5:TucA[^\n" ) ; break ;
    case 6 : fprintf(fp, "6:Ӎđg^\n" ) ; break ;
    case 7 : fprintf(fp, "7:ݕӌ^\n" ) ; break ;
    case 8 : fprintf(fp, "8:oH^\n" ) ; break ;
    case 9 : fprintf(fp, "9:SeqConstruct\n" ) ; break ;
        default: CHKA(-1,-1,-1); break;
    }
    fprintf(fp, "cross(%lf:%d:", gap0->cross_rate, gap0->cross_count );
    if( gap0->cross_count == 0 ) fprintf(fp, "" );
    if( gap0->cross_count == 1 ) fprintf(fp, "P" );
    if( gap0->cross_count >= 2 ) fprintf(fp, "_" );
    if( gap0->cross_count == -1) fprintf(fp, "l" );
    fprintf(fp, ")\nˑRψٵڰ݁F" ) ;
    switch ( gap0->mutat_typ ) {
        case 0 : fprintf(fp, "NORMAL\n" ) ; break ;
        case 1 : fprintf(fp, "^\n" ) ; break ;
        case 2 : fprintf(fp, "}^\n" ) ; break ;
        case 3 : fprintf(fp, "QOPT^\n" ) ; break ;
        default: CHKA(-1,-1,-1); break;
    }
    fprintf(fp, "mutat(%lf", gap0->mutat_rate );
    fprintf(fp, ")elite(%d:", gap0->elite_prsv );
    if( gap0->elite_prsv == 0 ) fprintf(fp, "ۑȂ" );
    if( gap0->elite_prsv == 1 ) fprintf(fp, "ۑ" );
    fprintf(fp, ")repla(%d:", gap0->with_repla );
    if( gap0->with_repla == 0 ) fprintf(fp, "񕜌o" );
    if( gap0->with_repla == 1 ) fprintf(fp, "o" );
    fprintf(fp, ")sharing(%d:", gap0->sharing );
    if( gap0->sharing == 0 ) fprintf(fp, "OFF" );
    if( gap0->sharing == 1 ) fprintf(fp, "ON" );
    fprintf(fp, ")gap0(%d", gap0->gener_gap );
    fprintf(fp, ")loop(%d", gap0->loop );
    fprintf(fp, ")\n" );
    return( 0 );
}
/*  ID_ga_def_print ga1_def.txţق̓eOt@C֏o
********************************************************************/
static int ga_def_print(
    char    *fname )
{
    FILE    *fp = NULL;
    int     rc = 0;
    char    bf[256], *bp;

    if( fname[0] == '\0' )  { fprintf(logfp,"ga1_def.txţقȂ\n");  goto quit; }
    if( (fp=fopen(fname, "r")) == NULL )        goto                  err;
    fprintf(logfp,"ga`t@CF%s\n",fname);
    fprintf(logfp,"------------------------------\n");
    while( bp=fgets(bf, 256, fp) ) {
        if( bp[0] == '#' || bp[0] == '\n' ) continue;
        fprintf(logfp,"%s",bf);
    }
    fprintf(logfp,"------------------------------\n");
    rc = 0;
quit:
    if( fp != NULL )    fclose(fp);
    return( rc );
err:
    rc = 0;
    printf( "*** WARNING ̧(%s)݂܂BDefaultlZbg܂B\n", fname );
    goto                                                       quit;
}

/* ------------------- main -------------------------*/

/*  ID_test_normal  ga`t@CɂƐ㐔Ŏs
********************************************************************/
static int test_normal(
    struct  gaparm  *gap0,
    int     algotype)
{
    int     rc=0;
//  long    lval ;
    double  def_num, gval, lval , route_max = 0.0; // 2015.11.20 YS Add
    LSTSP lstsp1;
    GA1 ga1;

    // WKx֐͂sropƂ
    //ga1.fitnes_func = &GA1::bekiFITNES;   // problem_typeŕ (^Cv@1:TSP 2:ATSP 3:VRP 4: CVRP 5:MTSP)
    /*************************************************/
    /* t@C̓ǂݍ݁@&@GAp[^̕ύX */
    /*************************************************/
    if( gap0->cross_typ == 5 || gap0->cross_typ == 7 || gap0->cross_typ == 8 ) {  //KS130916add
        printf("Iy[^G[\n"); rc = -1;
        goto   exit1;
    }
    if( gap0->prob_fname[0] != '\0' ) {
        /* TSPLIB`̃t@Cǂݍ݁Af`p[^C@*/
        /*  gap.allele_number gbN
        /*  gap.gene_number = _
        /*  gap.popul_size = _*2.8 */
        if( (rc = tsplibRead(gap0->prob_fname, gap0, &ga1 )) < 0 )  goto exit1;
        if( rc != 0 ) gap0->problem_type = rc;  /* ^Cv@1:TSP 2:ATSP 3:VRP 4: CVRP 5:MTSP 13/02/25 YS */
        if( rc == VRP || rc == CVRP ) {
            /* `q@B-1̂Ƃ 130218 YS */
            CHKA(1,gap0->allele_number,gap0->gene_number);
            gap0->gene_number += gap0->allele_number - 1;
            /* VRPȂAuqopɕύX */
            //ga1.fitnes_func = &GA1::bekiFITNES_VRP;   // problem_typeŕ
        }
        //tspga0->gap = *gap0;
    }
    else { // ݃o[Wł́At@ĆA@\
        printf("݃o[Wł́At@ĆA@\\n");
        goto   exit1;
    }
    /* GAŉ@*/
    ga1.eda_no = 0;
    if ( (rc=gatsp_go( gap0, algotype, &def_num, &ga1,&gval )) < 0 ) { rc = -1 ; goto  exit1; }
    if( DBGF[21]) fprintf(logfp, "gaFunc:=%lf\n",gval) ; /* 98/08/24 */
    /* Otpf[^t@C̍쐬 */
    //out_gdata(&ga1,ga1.ans,ga1.gap.gene_number,1,"f`sroikrOj");
    /* LSŉ */
    //lstsp1.sagyo = ga1.sagyo;
    //lstsp1.ans = ga1.ans;
    //lstsp1.gap = ga1.gap;
    lstsp1.sagyo_max = ga1.sagyo_max;
    lstsp1.route_max = ga1.route_max;
    lstsp1.fitness = ga1.fitness;
    if ( (rc=lstsp_go( gap0, algotype, &def_num, &lstsp1, &ga1, &lval )) < 0 ) { rc = -1 ; goto  exit1; }

    //if ( (lval=lsFunc( gap0, algotype, argc, argv, argcend , sagyo_max, &defnum,  &ga1 )) < 0 ) { rc = -1 ; goto  exit1; }
    if( DBGF[21]) fprintf(logfp, "lsFunc:=%lf œKƂ̍=%lf\n",lval, def_num) ;
    /* Otpf[^t@C̍쐬 */
    //out_gdata(&ga1,ga1.ans,ga1.gap.gene_number,2,"f`sro&kri[gOj");
    /* LS̉Ȃǂf`ɖ߂ */
    //memcpy(ga1.ans,lstsp1.ansW, sizeof(ga1.ans) * ga1.gap.gene_number);
    //ga1.sagyo_max = lstsp1.sagyo_max  ;
    //ga1.route_max =lstsp1.route_max ;
    //ga1.fitness = lstsp1.fitness;
    //ga1.fitness = ga1.fitnes_func( ga1.ans, ga1.gap.gene_number, &ga1.sagyo_max, &ga1.gap); // problem_typeŕ
    if( ga1.gap.problem_type == VRP || ga1.gap.problem_type == CVRP ) {
        ga1.fitness = ga1.bekiFITNES_VRP( ga1.ans, ga1.gap.gene_number, &ga1.sagyo_max, &ga1.gap, &route_max) ; // rout_max̒ǉ 2015.11.20 YS
        //ga1.kai = ga1.route_max ; /* 13/06/19 */
    }
    else if( ga1.gap.problem_type == TSP || ga1.gap.problem_type == ATSP || ga1.gap.problem_type == MTSP ) {
        ga1.fitness = ga1.bekiFITNES( ga1.ans, ga1.gap.gene_number, &ga1.sagyo_max, &ga1.gap) ;
        //ga1.kai = kai ; /* 98/08/24 */
    }
    else CHKA(-1,-1,-1);

    if( gap0->problem_type == MTSP ) { /* MTSPȂ */
        /* TSP̌ʂ[gɕĂ݂ 2013.04.08 */
        if ( (rc=gaMTSP(&ga1 )) < 0 ) { rc = -1 ; goto  exit1; }
    }
    // œK̃t@CȂÃt@CƂُ̍o
    //if( (rc = Result_print(ga1.ans, ga1.sagyo_max, ga1.fitness, &ga1.gap, ga1.gap.prob_fname, ga1.gap.optsol_fname,&def_num
    //  , ga1.fitnes_func, &ga1)) < 0 ) goto exit1;
    if( (rc = Result_print(ga1.ans, ga1.sagyo_max, ga1.fitness, &ga1.gap, ga1.gap.prob_fname, ga1.gap.optsol_fname,&def_num
        , &ga1)) < 0 )  goto exit1;

    /* Otpf[^t@C̍쐬 */
    out_gdata(&ga1,ga1.ans,ga1.gap.gene_number,3,"GA_TSP ŏI");

    //gaFINAL(&ga1) ; // GẢ    // fXgN^[ɕύX2013.09.04 YS

exit1 :
    //if( rc < 0 ) {    //G[I܂́At@CǂłȂƂ
    //  gaFINAL(&ga1) ;// fXgN^[ɕύX2013.09.04 YS
    //}
    return(rc);
}
//extern int             *ans ;      //[gene_number] gatsp.c

//extern int get_ga1_popul_size();
//extern int get_ga1_gcro(int no,int    *gcro);

/*  ID_lsAll    
********************************************************************/
static int lsAll(
    struct gaparm   *gap0,
    int     algotype,
    double  *def_num,
    class LSTSP *lstsp0,
    class GA1 *ga0,
    double  *gval)
{
    int     rc = 0,popul_size,  best_no, i;
    double   lval, best_val, defnum = 0;

    /* ga0->cŎĂoya_gcro[]ɂāAlsFuncĂ݂@ŗǉԂ */
    /* ̐́H */
    popul_size = ga0->get_ga1_popul_size();
    best_val = lstsp0->sagyo_max; best_no = -1;
    for( i = 0; i < popul_size; i++ ) {
        if( (rc = ga0->get_ga1_gcro(i, ga0->ans)) < 0 )      goto quit;
        if ( (rc=lstsp_go( gap0, algotype, &defnum, lstsp0, ga0, &lval )) < 0 ) { rc = -1 ; goto  quit; }
        if( lval < best_val )  {
            best_val = lval;
            best_no = i;
            *def_num = defnum;
        }
    }
    *gval = best_val;
quit:
return(rc);

}
/*  ID_test_many    eP[XɂĕeXg
********************************************************************/
static int test_many(
    struct  gaparm  *gap0,
    int     algotype)
{
    int     rc=0, cnt = 0;
    int     loop, t_i, j, cross_typ, sav_loop;
    double  lval, /*lval2,*/ gval, calc_time, def_num;
    char    csv_fname[256];
    time_t  timer;
    struct  tm *local;
    clock_t start,end;
    FILE    *csvfp = NULL;
    class LSTSP lstsp1;
    class GA1 ga1;

    start = clock();

    /* s */
    /* ݎ擾 */
    timer = time(NULL);
    local = localtime(&timer); /* nɕϊ */

    // WKx֐͂sropƂ
    //ga1.fitnes_func = &bekiFITNES;    // problem_typeŕ
    /*************************************************/
    /* t@C̓ǂݍ݁@&@GAp[^̕ύX */
    /*************************************************/
    if( gap0->prob_fname[0] != '\0' ) {
        /* TSPLIB`̃t@Cǂݍ݁Af`p[^C@*/
        /*  gap.allele_number gbN
        /*  gap.gene_number = _
        /*  gap.popul_size = _*2.8 */
        if( (rc = tsplibRead(gap0->prob_fname, gap0, &ga1 )) < 0 )  goto exit1;
        if( rc != 0 ) gap0->problem_type = rc;  /* ^Cv@1:TSP 2:ATSP 3:VRP 4: CVRP 5:MTSP 13/02/25 YS */
        if( rc == VRP || rc == CVRP ) {
            /* `q@B-1̂Ƃ 130218 YS */
            CHKA(1,gap0->allele_number,gap0->gene_number);
            gap0->gene_number += gap0->allele_number - 1;
            //ga1.fitnes_func = &bekiFITNES_VRP;    // problem_typeŕ
        }
        //tspga0->gap = *gap0;
    }
    else { // ݃o[Wł́At@ĆA@\
        printf("݃o[Wł́At@ĆA@\\n");
        goto   exit1;
    }
    /* SނɕύX㐔POO`POOOOOŎs@ʂCSVt@Co */
    t[0].loop = 100;
    t[1].loop = 1000;
    t[2].loop = 10000;
    t[3].loop = 100000;
    sav_loop = gap0->loop;
    if( gap0->prob_fname[0] != '\0' ) {
        sprintf(csv_fname,"%s.csv",gap0->prob_fname);
        if( (csvfp = fopen(csv_fname,"w")) == NULL ) { 
            printf("t@CI[vG[(%s)\n",csv_fname);
            rc = -1; goto exit1; }
//KS130820chg       if( (csvfp = fopen(csv_fname,"w")) == NULL ) goto exit1;  rc = 0 ̂܂܂ gaFINAL Ă΂Ȃ
        //fprintf(csvfp, "%s œKƂ̍كOtiPʁFj\n", gap0->prob_fname);  //iPʁFj폜
        fprintf(csvfp, "%s KxƍœKƂ̍كOt\n", gap0->prob_fname);
        /* s ݎ\ */
        fprintf(csvfp,"s: %4d/%02d/%02d %02d:%02d:%02d\n"
            ,local->tm_year + 1900, local->tm_mon + 1, local->tm_mday, local->tm_hour, local->tm_min, local->tm_sec);
        fprintf(csvfp, ",㐔\n");
        fprintf(csvfp, "@");
        for(loop = 100; loop <= gap0->loop; loop*=10 ) { /* 㐔4 100,1000,10000,100000 */
            fprintf(csvfp, ",'%d", loop);
        }
        //fprintf(csvfp, ",lsFunc,lsAll\n");
        fprintf(csvfp, ",lsFunc,𓚂Ƃ̍فij\n");  // 2015.11.09 YS
        ga1.eda_no = 0;
        for( cross_typ = 1; cross_typ <= 9; cross_typ++ ) { /* 6 1,2,3,4,6,9 */
//      for( cross_typ = 9; cross_typ <= 9; cross_typ++ ) { /* 6 1,2,3,4,6,9 */ // for debug
            if( cross_typ == 5 || cross_typ == 7 || cross_typ == 8 ) continue;
            for( j = 0; j < 5; j++ ) { // eXg񐔁@T
                gap0->cross_typ = cross_typ;
                ga1.eda_no = j+1;   // ʏo͗p}
                fprintf(csvfp, "No.%d ", ++cnt);
                fprintf(csvfp, "%d:", gap0->cross_typ);
                switch ( gap0->cross_typ ) {
                    case 0 : fprintf(csvfp, "NORMAL" ) ; break ;
                    case 1 : fprintf(csvfp, "^" ) ; break ;
                    case 2 : fprintf(csvfp, "ʒu^" ) ; break ;
                    case 3 : fprintf(csvfp, "ʑ^" ) ; break ;
                    case 4 : fprintf(csvfp, "z^" ) ; break ;
                    //case 5 : fprintf(csvfp, "TucA[^" ) ; break ;
                    case 6 : fprintf(csvfp, "Ӎđg^" ) ; break ;
                    //case 7 : fprintf(csvfp, "ݕӌ^" ) ; break ;
                    //case 8 : fprintf(csvfp, "oH^" ) ; break ;
                    case 9 : fprintf(csvfp, "SeqConstruct" ) ; break ;
                    default: CHKA(-1,-1,-1); break;
                }
                fprintf(csvfp, "%d", j+1);
                gap0->loop = sav_loop + 1;
                if ( (rc=gatsp_go( gap0, algotype, &def_num, &ga1, &gval )) < 0 ) { rc = -1 ; goto  exit1; }
                /* Otpf[^t@C̍쐬 */
                //out_gdata(&ga1,ga1.ans,ga1.gap.gene_number,1,"f`sroikrOj");

                printf( "No(%d)cross_typ(%d) loop(%d) =%lf\n",cnt, gap0->cross_typ, gap0->loop, gval) ; /* 98/08/24 */
                /* gatsp_go()ł́AœKǂ܂Ȃ@䂦ɍقł͂ȂłSo͂Ă 2015.11.20 YS */
                if( rc == 1 ) { // œKt@C@قo
                    for( t_i = 0; t_i < 4;  t_i++ )
                        if( t[t_i].loop < gap0->loop && t[t_i].def_num >= 0.0 ) fprintf(csvfp, ",%lf", t[t_i].def_num);
                        else break;
                }
                else {// œKt@CȂ@So
                    // S~߂āAKxɕύX 2015.11.27 Y.S
                    //for( t_i = 0; t_i < 4;    t_i++ )
                    //  if( t[t_i].loop < gap0->loop && t[t_i].kai >= 0.0 ) fprintf(csvfp, ",%lf", t[t_i].kai);
                    //  else break;
                    for( t_i = 0; t_i < 4;  t_i++ )
                        if( t[t_i].loop < gap0->loop && t[t_i].fitnes >= 0.0 ) fprintf(csvfp, ",%lf", t[t_i].fitnes);
                        else break;
                }
                lstsp1.sagyo_max = ga1.sagyo_max;
                lstsp1.route_max = ga1.route_max;
                lstsp1.fitness = ga1.fitness;
                lval = 0.0;
                if ( (rc=lstsp_go( gap0, algotype, &def_num, &lstsp1, &ga1, &lval )) < 0 ) { rc = -1 ; goto  exit1; }
                /* Otpf[^t@C̍쐬 */
                //out_gdata(&ga1,ga1.ans,ga1.gap.gene_number,2,"f`sro&kri[gOj");
                fprintf(logfp, "lsFunc:=%lf œKƂ̍=%lf\n",lval, def_num) ;
                // 2015.11.09 YS
                //krł̑Só@lstsp_go()ł́AœKt@Cǂł
                // krł̃tBbglXo 2015.11.27 Y.S
                //fprintf(csvfp, ",%lf",lval); fflush(csvfp);
                fprintf(csvfp, ",%lf",lstsp1.fitness ); fflush(csvfp);
                if( rc == 1 ) { // œKt@C@قo
                    fprintf(csvfp, ",%lf",def_num); fflush(csvfp);
                }
                else {// œKt@CȂ@- o
                    fprintf(csvfp, ",-"); fflush(csvfp);
                }
                CHKBD(0.0,lval,gval);
//KS130827add ==> 
#ifdef Z0// manył͂kr܂ł̌ʂr邾A͒ǉȂĂƎvBʃOt㏑ČȂA
        // łf`񂵂Ă邩玞Ԃ߂IMTSP̌ʂrȂvȎ̕ƏCȂĂ͂Ȃ2013.08.30YS
                if( gap0->problem_type == MTSP ) { /* MTSPȂ */
                    /* TSP̌ʂ[gɕĂ݂ 2013.04.08 */
                    if ( (rc=gaMTSP(&ga1 )) < 0 ) { rc = -1 ; goto  exit1; }
                }
                // œK̃t@CȂÃt@CƂُ̍o
                if( (rc = Result_print(ga1.ans, ga1.sagyo_max, ga1.fitness, &ga1.gap, ga1.gap.prob_fname, ga1.gap.optsol_fname,&def_num
                    , ga1.fitnes_func, &ga1)) < 0 ) goto exit1;
#endif
//<==KS130827add 
#ifdef Z0 // lςȂ̂ŁA폜
                /* lsFunccĂSɂĂ݂ */
                if ( (rc=lsAll( gap0, algotype, &def_num, &lstsp1, &ga1, &lval2 )) < 0 ) { rc = -1 ; goto  exit1; }
                fprintf(logfp, "lsAll:=%lf œKƂ̍=%lf\n",lval2, def_num) ;
                if( rc == 1 ) { // œKt@C@قo
                    fprintf(csvfp, ",%lf",def_num); fflush(csvfp);
                }
                else {// œKt@CȂ@So
                    fprintf(csvfp, ",%lf",lval2); fflush(csvfp);
                }               CHKBD(0.0,lval2,gval);
                CHKBD(lval2,lval,gval);
#endif
                fprintf(csvfp, "\n"); fflush(csvfp);
            }
        }
        fprintf(csvfp, "\n");
        if( algotype == 0 ) Gap_print( csvfp, gap0 );       // GA̎͏o
    }
    //gaFINAL(&ga1); // fXgN^[ɕύX2013.09.04 YS
    /*  */
    end = clock();
    calc_time = (double)(end-start)/CLOCKS_PER_SEC;
    fprintf(logfp,":%lf\n",calc_time);
    if( csvfp != NULL ) fprintf(csvfp,":%lf\n",calc_time);
    rc = 0;
exit1 :
    //if( rc < 0 ) { gaFINAL(&ga1); }  // fXgN^[ɕύX2013.09.04 YS
    if( csvfp != NULL ) {fclose(csvfp); csvfp = NULL;}
    return(rc);
}
/* Sf[^eXgp */
static int test_all_file(
    struct  gaparm  *gap0,
    int     algotype)
{
    FILE    *fp = NULL;
    int     rc = 0;
    char    bf[256], *bp, pfname[64], sfname[64];
    clock_t start,end;
    double  calc_time;

    /* eXgvt@Cɂt@CɂāASeXgs */
    if( (fp=fopen("test_plan.txt", "r")) == NULL ) goto                exit1;
    while( bp=fgets(bf, 256, fp) ) {
        if( bf[0] == '#') continue;
        start = clock();
        sscanf(bf,"%s %s",pfname, sfname);
        strcpy(gap0->prob_fname, pfname); // t@CZbg
        strcpy(gap0->optsol_fname, sfname); // 𓚃t@CZbg
        printf("%s\n",pfname);
        fprintf(logfp, "%s ,",pfname); fflush(logfp);
        /* m[}eXgp */
        //if( (rc = test_normal(gap0,algotype)) < 0 ) goto          exit1;
        // mallocłȂĂÃf[^̏Ă݂ 2015.05.07 YS
        rc = test_normal(gap0,algotype);
        end = clock();
        calc_time = (double)(end-start)/CLOCKS_PER_SEC;
        fprintf(logfp,":%lf\n",calc_time);

    }
exit1 :
    if( fp != NULL ) {fclose(fp); fp = NULL;}
    return(rc);
}
void yuko_test()
{
    double *xy_cost;
    int     rc, m, size,size2, max;

    max = (int)sqrt((double)INT_MAX / sizeof(*xy_cost));
    m = 33810;
    size = m*m ;
    //xy_cost = (double *)malloc( m*m * sizeof(*xy_cost));
    xy_cost = (double *)malloc( INT_MAX);
    if( xy_cost == NULL ) {
        printf("mۂł܂(%d)\n",size);
        rc = -1;
        goto quit;
    }
    xy_cost[size-10] = 0.0;
    size2 = 2051*33810+30146;
    xy_cost[size2] = 0.0;
    xy_cost[2051*33810+30146] = 0.0;
quit:
    return;
}
int main(
    int     argc,
    char    *argv[])
{
    int     rc=0, i, algotype, selec_typ, argcend, cnt = 0;
    double  calc_time;
    char defName[256], pfname[256], sfname[256], dummy[356];
    time_t timer;
    struct tm *local;
    clock_t start,end;
    struct gaparm   gap ;
    //int ymd;         del 2019/12/02 N.Tsuchiya
    //struct tm *tm1;
    //time_t ltime;

    ////t`FbN 20161231 ȍ~Ȃ 
    //time( &ltime );
    //tm1 = gmtime( &ltime );
    //ymd = (tm1->tm_year +1900)*10000 + (tm1->tm_mon+1)*100 + tm1->tm_mday;
    //if( ymd > 20161231 ) goto exit1; 

    start = clock();

    //yuko_test();
    /* Ot@CI[v */
    // Ot@C|C^
    if( (logfp = fopen("ga_tsp.log","w")) == NULL ) goto exit1;
    /* s */
    /* ݎ擾 */
    timer = time(NULL);
    local = localtime(&timer); /* nɕϊ */
    /* n ϊ\ */
    fprintf(logfp,"s: %4d/%02d/%02d %02d:%02d:%02d\n"
        ,local->tm_year + 1900, local->tm_mon + 1, local->tm_mday, local->tm_hour, local->tm_min, local->tm_sec);
    /* R}hC */
    fprintf(logfp,"sR}hF\n") ;
    for ( i=0 ; i<argc ; i++ ) fprintf(logfp, "%s ", argv[i]) ;
    fprintf(logfp,"\n\n") ;
    /************************/
    /* GAp[^̃Zbg */
    /************************/
    /* ܂͏ */
    gap = init_gap;
    /* AASY^CvAI^CvA`t@C𓾂 */
    if ( (rc = argcend = argparm( argc, argv, &algotype, &selec_typ, defName, pfname, sfname )) < 0 ) goto exit1 ;
    if( algotype != 0 )  { // ݃o[Wł́AGAȊÓA@\@q[XeBbN͖
        printf("݃o[Wł́Aq[XeBbN͖\n");
        goto   exit1;
    }
    if ( defName[0] == '\0' ) strcpy( defName, "ga1_def.txt" ) ;
    // ga1_def.txţُo fobOvg
    ga_def_print( defName );
    /* `t@CZbg */
    if ( (rc = Get_default( defName, &gap, &algotype )) < 0 ) goto exit1 ;
    /* p[^ł̎w͎~߁AliPjZbgĂ邾Ȃ̂ŁAt@C̒lgƂɕύX 2015.10.26 YS */
    //gap.selec_type = selec_typ ;  // t@Cwp[^wD
    if( gap.selec_type != SELEC_TYPE_RAND && gap.selec_type != SELEC_TYPE_RANK 
        && gap.selec_type != SELEC_TYPE_HOPE ) {
        gap.selec_type = selec_typ ; // liPF[bgjZbg
    }
        
    strcpy(gap.prob_fname, pfname); // t@CZbg
    strcpy(gap.optsol_fname, sfname); // 𓚃t@CZbg
    if( algotype == 0 ) Gap_print( logfp, &gap );       // GA̎͏o

    /************************/
    /* srof`ŉ   */
    /************************/
    /* čeXgp */
    /* Sތ㐔POO`POOOOOłTeXgs@ʂCSVt@Co */
    if( strncmp(gap.prob_fname,"MANY_",5) == 0 ) {
        strcpy(dummy,gap.prob_fname+5);
        strcpy(gap.prob_fname,dummy);
        if( (rc = test_many(&gap, algotype )) < 0 ) goto              exit1;  //SĂ̌s
    }
    // t@C"TEST_ALL"ȂAtest_plan.txt t@C̃f[^SɂăeXg 
    else if( strcmp(gap.prob_fname,"TEST_ALL") == 0 ) {
        /* Sf[^eXgp */
        if( (rc = test_all_file(&gap,algotype)) < 0 ) goto          exit1;
    }else {
        /* m[}eXgp */
        if( (rc = test_normal(&gap,algotype)) < 0 ) goto            exit1;
    }
    /*  */
    end = clock();
    calc_time = (double)(end-start)/CLOCKS_PER_SEC;
    fprintf(logfp,":%lf\n",calc_time);
    rc = 0;
exit1 :
    if( logfp != 0 ) {fclose(logfp); logfp = 0;}
    return(rc);
}
