/*
 *	FILE	 : ga0->h
 *	SYSTEM	 : `ASY(GA:Genetic Algorithm)
 *	FUNCTION :
 *	AUTHER	 : s.kobayashi 1994/01/14
 *  MODIFY   : Y.Shibaski 2013.04.19 NX
 */
#ifndef GA1_h
#define GA1_h
#include "gaparm.h"
typedef struct gcro_st {/* F́ij */
	int 	*chrom ;	/* F */
	double	fitnes ;	/* Kx -1̎Av`q07/29 */
	double	prob ;		/* Im */
	double	expec ;		/* IҒl */
	char	selsumi ;	/* Iς݃tOBPƂȂ͉LB*/
						/* VFAOnmœ̈`qɑ݂ƂB*/
						/* 񕜌oŐeƂĂPI΂ꂽƂB*/
						/* Ғl헪ŊҒlOƂȂƂB*/
	double	kai ;		/* ̒l98/08/24 ǉ */
	char	dummy ;		/* */
	gcro_st(){ chrom = 0; }  //KS130904add
} GCRO ;
struct gcrowk_st {		/* F́ij \[gp */
	int		no;			/* ԍ */
	int 	*chrom ;	/* F */
	double	fitnes ;	/* Kx -1̎Av`q07/29 */
	char	selsumi ;	/* Iς݃tOBPƂȂ͉LB*/
						/* VFAOnmœ̈`qɑ݂ƂB*/
						/* 񕜌oŐeƂĂPI΂ꂽƂB*/
						/* Ғl헪ŊҒlOƂȂƂB*/
}  ;
struct edgelist_st {
	int		oya[4];     //[0], [1]eP̒́ȂOƌ̓ss
	                    //[2], [3]eQ̒́ȂOƌ̓ss
	int		num;        //ss
};
 void Xfree( //ptr )
	void	*ptr);
/**************/
/* GA1 NX */
/**************/
class GA1 { 
  public:
 	double	min_val ;		/* rand()̃^[lmin,max */
	double	max_val ;
	GCRO	*oya_gcro ;		/* e̐F̏B[].chromintgcro[]Ƌp */
	GCRO	*ko_gcro ;		/* q̐F̏ */
	GCRO	taro_gcro ;		/* Pq̐F̏ */
	GCRO	hana_gcro ;		/* Qq̐F̏ */
	int 	*kousa ;		/* ʒue[u kousa[x_len] */
	int 	**intgcro ;		/* [x_ko][x_len]Boya_gcro[].chromƋp */
	int 	*allele ;		/* ̒l̎蓾鐔BPȏ */
	int 	*order ;		/* \[eBOp[N */
	struct	gcrowk_st *sortwk ;		/* \[eBOp[N */
	int 	*chk ;			/* TSP _̏dCHKp 2012.01.09 */
	int		n_ko ;			/* q̌̐ */
	int		x_ko ;			/* P̌̐(gaparm->popul_size) */
	int		x_len ;			/* F̒(len) */
	int		x_loop, n_loop ;/* ̌֐ x_loop = loop */
	int		*sawkval ;		/* ^Aʒu^̎Ɏgp郏[NGA 98/06/18 */
	int		*sawkkousa ;	/* kousa[]ۑp 98/06/18 */
	int		DBGsk ;			//= 0;
	struct edgelist_st *edgelist;/* Ӎđg^̎Ɏgp郏[NGA 15.05.18 */
	int		*edgelist2;		/* SCX̎Ɏgp郏[NGA 15.05.23*/
	int		*ans ;			//[gene_number]
	double	*rank;			//[popul_size]
	double	**sagyo ;		//[gene_number] [gene_number]
	double	*mcn ;			//[allele_number]
	double	total_sagyo ;	//es̍ől̍v
	double	optimalValue;	// VRPLIBǂݍݗp 130219 YS
	double	*route_num;		// VRP e[gƂ̍v 130222 YS
	double	route_max;		// VRP S[g̍ől 130617 YS
	double	sagyo_max;		// VRP S[g̍v 130617 YS
	double	fitness;		// VRP Kx 130617 YS
	struct	gaparm	gap ;
	double	*xy_cost;		// TSPLIBǂݍ񂾋iRXgj\
	double	*xcoord;		// TSPLIBǂݍ񂾂wW 2013.06.10 YS Otpf[^t@Cɏo͂̂
	double	*ycoord;		// TSPLIBǂݍ񂾂xW 2013.06.10 YS Otpf[^t@Cɏo͂̂
	int		eda_no;			// ʏo͗p}
	//double	(GA1::*fitnes_func)(int*, int, double *, struct gaparm *); /* KxvZ֐ double *kaiǉ */

   // ftHgRXgN^.
    GA1()
	{
		min_val = 0.0;
		max_val = 0.0;
		n_ko = 0;
		x_ko = 0;			
		x_len = 0;		
		x_loop = 0;
		n_loop = 0;
		DBGsk = 0;
		total_sagyo = 0.0;
		optimalValue = 0.0;
		route_num = NULL;
		route_max = 0.0;
		sagyo_max = 0.0;
		fitness = 0.0;
		eda_no = 0;

		oya_gcro = NULL;
		ko_gcro = NULL;
		kousa = NULL;
		intgcro = NULL;
		allele = NULL;
		order = NULL;
		chk = NULL;
		taro_gcro.chrom = NULL;
		hana_gcro.chrom = NULL;
		sawkval = NULL;
		sawkkousa = NULL;
		edgelist= NULL;
		edgelist2= NULL;
		ans = NULL;
		rank= NULL;
		sagyo = NULL;
		mcn = NULL;
		route_num= NULL;
		xy_cost= NULL;
		xcoord= NULL;
		ycoord= NULL;
		//fitnes_func = NULL;
		sortwk  = NULL;  // 15.06.29
	}

    // fXgN^.
    ~GA1()
	{
		int 	rc=0, i;

		if (DBGF[9]) fprintf(logfp, "~GA1 >>>\n") ;
		if( ans ) free( (char*)ans ), ans = NULL;
		if( allele ) free( (char*)allele ), allele = NULL;
		if( rank ) free( (char*)rank ), rank = NULL;
		if( sagyo ) free( (char*)sagyo ), sagyo = NULL;
		if( mcn ) free( (char*)mcn ), mcn = NULL;
		if( chk ) free( (char*)chk ), chk = NULL;
		if( route_num ) free( (char*)route_num ), route_num = NULL;
		if( xy_cost ) free( (char*)xy_cost ), xy_cost = NULL;

		if( oya_gcro ) {
			for (i=0 ; i<x_ko ; i++ )
				if( oya_gcro[i].chrom ) Xfree( (char*)oya_gcro[i].chrom ) ;
			Xfree( (char*)oya_gcro ), oya_gcro = NULL ;
		}
		if( ko_gcro ) {
			for (i=0 ; i<x_ko ; i++ )
				if( ko_gcro[i].chrom ) Xfree( (char*)ko_gcro[i].chrom ) ;
			Xfree( (char*)ko_gcro ), ko_gcro = NULL ;
		}
		if( taro_gcro.chrom ) Xfree( (char*)taro_gcro.chrom ), taro_gcro.chrom = NULL;
		if( hana_gcro.chrom ) Xfree( (char*)hana_gcro.chrom ), hana_gcro.chrom = NULL;
		if( kousa ) Xfree( (char*)kousa ), kousa = NULL ;
		if( order ) Xfree( (char*)order ), order = NULL ;
		if( sawkval ) Xfree( (char*)sawkval ), sawkval = NULL ;				/*98/06*/
		if( sawkkousa ) Xfree( (char*)sawkkousa ), sawkkousa = NULL ;	/*98/06*/
		if( edgelist ) Xfree( (char*)edgelist ), edgelist = NULL ;	/*13/02*/
		if( edgelist2 ) Xfree( (char*)edgelist2 ), edgelist2 = NULL ;	/*15/05*/
		if( intgcro ) Xfree( (char*)intgcro ), intgcro = NULL ;
		if( chk ) Xfree( (char*)chk ), chk = NULL ;
		if( xcoord ) Xfree( (char*)xcoord ), xcoord = NULL ;  //15.06.29
		if( ycoord ) Xfree( (char*)ycoord ), ycoord = NULL ;  //15.06.29
		if( sortwk ) Xfree( (char*)sortwk ), sortwk = NULL ;  //15.06.29

		if (DBGF[9]) fprintf(logfp, "<<< ~GA1\n") ;
	}

    // Zq.
//    GA1& operator=(const GA1& other);

    // ANZbT.
//    const char* getValue() const;
//    void setValue(const char* value);

    // Zq.
//    bool operator==(const GA1& other) const;
//    bool operator!=(const GA1& other) const;
// <- TODO ***************

	//lsfunc ɂāASĂ ans[] vZāAœK߂ۂɎgp
	void get_ans( int n, int *ansL );
	/* ga1̌̐擾 */
	int get_ga1_popul_size();
	/* ga1̐eF̏擾 */
	int get_ga1_gcro(	int no,	int	*gcro);
	/* ͈[0.0, 1.0)̊Ԃŗ𔭐*/
	double RANDsk( );
	/* eq邩H */
	int gaKOUSA( double cross_rate );
	/* ֐rand( )̏lݒ */
	int RANDinit( );

	double bekiFITNES( 	/* sropKxZo */
	int 	*chrom,
	int 	len ,
	double	*kai,
	struct gaparm * gap);
	
	double bekiFITNES_VRP( /* uqopKxZo */
		int 	chrom[],
		int 	len ,
		double	*kai,
		struct gaparm * gap,
		double	*route_max); // 2015.11.20 YS Add
	private:

};  // class end


/*****************/
/* ֐`      */
/*****************/

/* f`̎s */
int ga1_go( 
	class GA1 *ga0,
	int 	(*initmk)(int ** ,int *,int ,int, class GA1 * ) );	/* (i)𔭐֐ */

 #define M_PI	   3.14159265358979323846

#define GEO_PI 3.141592 /* PI with the prescision given by Reinelt */
#define NINT(X) ((int) floor(X + 0.5))

#define	ATSP_NAME_MAX	256
#define UNKNOWN_PROB_TYPE 0
#define UNKNOWN_TYPE 0
#define UNKNOWN_FORMAT 0
#define EXPLICIT 1
#define EUC_2D 2
#define EUC_3D 3
#define MAX_2D 4
#define MAX_3D 5
#define MAN_2D 6
#define MAN_3D 7
#define CEIL_2D 8
#define GEO 9
#define GEOM 10
#define ATT 11

#define FULL_MATRIX 1
#define UPPER_ROW 2
#define LOWER_ROW 3
#define UPPER_DIAG_ROW 4
#define LOWER_DIAG_ROW 5
#define UPPER_COL 6
#define LOWER_COL 7
#define UPPER_DIAG_COL 8
#define LOWER_DIAG_COL 9
#define FUNCTION 10
#define READERROR -1


/* GATSP̎s */
 int gatsp_go(
	struct gaparm	*gparm,
	int 	algotype,
	double	*def_num,
	class GA1 *ga0,
	double *sagyo_max);
/* _ʂĂȂ̃`FbN */
int chk_same_point_tsp(
	int	*path,
	int	num,
	int *chk);
/* t@Co */
// œK̃t@CȂÃt@CƂُ̍o

int Result_print(
	int		*ans,
	double	sagyo_max,
	double	fitness,
	struct	gaparm	*gap,
	char	*fname,
	char	*fname_opt,
	double	*def_num,
//	double	(*fitnes_func)(int*, int, double *, struct gaparm *, class GA1 *),
	class GA1 *ga0);		/* (i)KxvZ֐ */
/* TSPLIB`̃t@Cf[^ǂ VRPLIB`ǉ */
int	tsplibRead(    // 1-4:ǂݍ񂾃t@C̃^Cv 0:ɓ͍ <0:G[
	char *fname,
	struct gaparm	*gparm,
	class GA1 *ga0);

#ifdef Z0
	/* uqopKxZo */
double bekiFITNES_VRP( 
	int 	chrom[],
	int 	len ,
	double	*kai,
	struct gaparm * gap,
	class GA1 *ga0); // route_max Ԃ
double bekiFITNES( 
	int 	chrom[],
	int 	len ,
	double	*kai, // ԂĂȂ@max_spnԂ悤ɏC
	struct gaparm * gap,
	class GA1 *ga0); // route_max Ԃ
#endif
int Gap_print( FILE *fp, struct gaparm *gap0);
// SsԂԂ
double Eval( /*n_job, n_mcn, sagyo, ans, mcn )	/* łKvȊ֐ */
	int		n_job,
	int		n_mcn,
	register double	**sagyo,   // ZFd̎dł́A͒i莞
	register int 	*ans,
	register	double *mcn );    // ZFd̎dł́AɍƎԂĂ邩

/* Otpf[^t@C̍쐬 */
int out_gdata(
class GA1 *ga0,
int		m_ans[],    /* i  */
int		len,		/* i ̒ */
int		no,			/* i t@Cʔԍ */
char	*coment);

/* fobOtOTCY擾 2015.11.30 YS */
int DBGF_init_size();
int DBGF_size();
#endif /* GA1_h */


