/*
 * file		: gamtsp.c
 * system	: `ASYga1()̃eXgp
 * function	: Z[X}̗
 * auther	: 2012.12.14 Y.Shibasaki
 */
#pragma warning(disable:4996)

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<malloc.h>
#include	<memory.h>
#include	<time.h>
#include	"ssc.h"
//#include	"gaparm.h"
//#define _USE_MATH_DEFINES  // M_PÎ
#include <math.h>
//#define M_PI	   3.14159265358979323846
#include "ga1.h"
#include	"lstsp.h"
//#include "gatsp.h"
/****************/


/*	ID_get_route_num	w苗Ń[g؂Ƃ̃[gԂ
********************************************************************/
static int get_route_num(  /* [g */
int		num,		/* i _ */
int		ans[],		/* i _̈ʒu */
int		start,		/* i Jnʒu@OȊO̎́AŏI_擪_ʂA擪_ɖ߂܂ł̃[gl */
double	**sagyo,	/* i e_Ԃ̋ */
double	*len,		/* io [giZ[gɕj */
int		ret_ans[],	/* o ؂ꂽ_̈ʒu NULL̂Ƃ́AɃZbgȂij*/
class GA1 *ga0)
{
//	int 	i, j, first, next, cnt = 0, rcnt = 0, acnt = 0;  KS130827chg next ݒQƂ\
	int 	i, j, first, next = -1, cnt = 0, rcnt = 0, acnt = 0;
	double	total = 0.0, old_total, max;
//	CHKB ( EPS,(*len),(*len) ) ;  KS130827chg
	CHKBD( EPS,(*len),(*len) ) ;
	if(DBGF[25]>1) fprintf(logfp,"***** start(%d) len(%lf)\n",start,(*len)); fflush(logfp);
	max = 0; rcnt = 0;
	for ( i = start; i < num+start-1; i++ ) {
		if( i >= num ) j = i - num;
		else           j = i;
		first = ans[j];			CHKA(0,first,num);
		if( j+1 == num ) 	next = ans[0];
		else				next = ans[j+1];
			CHKA(0,next,num);
		old_total = total;
		total += sagyo[first][next];
		if( ret_ans != NULL ) {	ret_ans[rcnt] = first;	rcnt++;	}
		if( total > *len) { /* [g𒴂 */
			/* P_݂̂Ȃ */
			if( old_total == 0.0 )if(DBGF[25]>1) fprintf(logfp,"rout%d) %d -> %lf\n",cnt+1, j, old_total); 
			if( old_total > max ) max = old_total;  CHKAD(old_total ,(*len),total);
			cnt++;
			total = 0;
			if( ret_ans != NULL ) {
				ret_ans[rcnt] = ga0->gap.gene_number + acnt; /* ؂苒_͋_ȍ~̐ */
				rcnt++; acnt++;
			}
		}
		else {
			if(DBGF[25]>1) fprintf(logfp,"rout%d) %d-%d (%lf) -> %lf\n",cnt+1, first, next,sagyo[first][next],total); 
		}
	}
	if( ret_ans != NULL ) {	ret_ans[rcnt] = next;	rcnt++;	}

	/* ŌɂP_݂̂Ȃ */
	if( total == 0.0 )if(DBGF[25]>1) fprintf(logfp,"rout%d) %d -> %lf\n",cnt+1, j, total); 

	/* Ō̃g[^r */
	if( total > max ) max = total;  //CHKAD(old_total ,total,(*len));

	*len = max;
	if(DBGF[25]>1) fprintf(logfp,"*len(%lf) rout_num(%d)\n",*len, cnt); fflush(logfp);
	return( cnt+1 ) ;
}

/*	ID_out_gdata	Otpf[^t@C̍쐬
********************************************************************/
int out_gdata(
class GA1 *ga0,
int		m_ans[],    /* i  */
int		len,		/* i ̒ */
int		no,			/* i t@Cʔԍ */
char	*coment)
{
	int		rc = 0, i;
	char	ofname[256], time_st[256], *poi;
    time_t timer;
	struct tm *local;
	FILE	*ofp = NULL;
	int		first, next;
	double	total, s_num;

	/* EDGE_WEIGHT_SECTION̎́AOtf[^o͂Ȃ */
	if( ga0->xcoord == NULL ) {
		printf("EDGE_WEIGHT_SECTION̎́AOtf[^o͂ł܂\n");
		fprintf(logfp,"EDGE_WEIGHT_SECTION̎́AOtf[^o͂ł܂(%s)\n",ga0->gap.prob_fname);
		goto quit;
	}
	/* o̓t@Ci薼{rout{N.csvj*/
	strcpy(ofname,ga0->gap.prob_fname);
	poi= strrchr(ofname,'.');
	if( poi == NULL ) goto quit;
	timer = time(NULL);
    local = localtime(&timer); /* nɕϊ */
    /* n ϊ\ */
	//sprintf(time_st,"%4d%02d%02d%02d%02d%02d"
	//	,local->tm_year + 1900, local->tm_mon + 1, local->tm_mday, local->tm_hour, local->tm_min, local->tm_sec);
	time_st[0] = '\0'; // _E[hł͔NȂ
	sprintf(poi, "_rout%s_%d.csv",time_st,no);
	//ofp = fopen(ofname,"w"); 2016.01.05 Y.S
	if( (ofp = fopen(ofname,"w")) == NULL ) {
		printf("t@C(%s)I[vł܂\n",ofname);
		rc = -1; goto quit;
	}
	fprintf(ofp,"%s\n",coment); fflush(ofp);
	fprintf(ofp,"No,wW,xW,,݌v\n" ); fflush(ofp);
	total = 0.0;
	for( i =0; i < len-1; i++ ) {
		first = m_ans[i]; next = m_ans[i+1];
		//if(DBGF[25]>0) fprintf(logfp,"total:%lf,first:%d,next:%d\n",total,first, next);
		if( i == 0 && first < ga0->gap.gene_number - ga0->gap.allele_number +1 ) { 
				fprintf(ofp,"%d,%lf,%lf,%lf,%lf\n",first, ga0->xcoord[first],ga0->ycoord[first], 0.0, total);
		}
		if( first >= ga0->gap.gene_number - ga0->gap.allele_number +1) {
			total = 0.0;
			if( next < ga0->gap.gene_number - ga0->gap.allele_number +1) { 
				fprintf(ofp,"%d,%lf,%lf,%lf,%lf\n",next, ga0->xcoord[next],ga0->ycoord[next], 0.0, total);
			}
		}
		else if( next >= ga0->gap.gene_number - ga0->gap.allele_number +1) {
			total = 0.0;
			fprintf(ofp,"\n");
		}
		else {
			s_num = ga0->sagyo[first][next];
			total += s_num;
			fprintf(ofp,"%d,%lf,%lf,%lf,%lf\n",next, ga0->xcoord[next],ga0->ycoord[next], s_num, total);
		}
	}
	/* TSP̎́A擪֖߂ */
	if( ga0->gap.problem_type == TSP || ga0->gap.problem_type == ATSP ) {
		first = m_ans[i]; next = m_ans[0];
		//if(DBGF[25]>0) fprintf(logfp,"total:%lf,first:%d,next:%d\n",total,first, next);
		if( i == 0 && first < ga0->gap.gene_number - ga0->gap.allele_number +1 ) { 
				fprintf(ofp,"%d,%lf,%lf,%lf,%lf\n",first, ga0->xcoord[first],ga0->ycoord[first], 0.0, total);
		}
		if( first >= ga0->gap.gene_number - ga0->gap.allele_number +1) {
			total = 0.0;
			if( next < ga0->gap.gene_number - ga0->gap.allele_number +1) { 
				fprintf(ofp,"%d,%lf,%lf,%lf,%lf\n",next, ga0->xcoord[next],ga0->ycoord[next], 0.0, total);
			}
		}
		else if( next >= ga0->gap.gene_number - ga0->gap.allele_number +1) {
			total = 0.0;
			fprintf(ofp,"\n");
		}
		else {
			s_num = ga0->sagyo[first][next];
			total += s_num;
			fprintf(ofp,"%d,%lf,%lf,%lf,%lf\n",next, ga0->xcoord[next],ga0->ycoord[next], s_num, total);
		}
	}
	fflush(ofp);
	fclose(ofp);
quit:
	return(rc);
}

/*	ID_gamtsp	TSP̌ʂAől[gŏ̕[gĂ
********************************************************************/
double gamtsp(  /* [g̍ől */
int		t_ans_num,		/* i TSP̉̐ */
int		t_ans[],		/* i TSP̉ */
int		route_num,		/* i [g */
double	**sagyo,		/* i e_Ԃ̋ */
int		m_ans[],		/* o MTSP̉ */
class GA1 *ga0)
{
	double	rc = 0.0;
	int 	i, first, next, start, route_num1, *w_ans = NULL, save_start, rcnt;
	double	total = 0.0, temp_length, old_temp_length, max, min, save_temp_length, save_temp_length1, s_num;

	CHKB(2,route_num,ga0->gap.gene_number);
	/* MTSP̉ꎞi[pGA */
	//if( (w_ans = (int*) malloc((ga0->gap.gene_number+ga0->gap.allele_number)*sizeof(*w_ans))) == 0 ) goto   quit;
	/* bli[g̍őljZo */
	/* blS[g */
	for ( i = 0; i < t_ans_num	; i++ ) {
		first = t_ans[i];			CHKA(0,first,t_ans_num);
		if( i+1 == t_ans_num ) 	next = t_ans[0];
		else							next = t_ans[i+1];
			CHKA(0,next,t_ans_num);
		total += sagyo[first][next];
	}
	temp_length = total / route_num;
	save_temp_length = save_temp_length1 = total;
	for( start = 0; start < t_ans_num; start++ )  { /* S_n_ɂČ@*/
		if( start == 10 ) {
			start = start ;
		}
		/* blł̃[g擾 */
		min = 0.0; max = temp_length *2;
		do {
			old_temp_length = temp_length;
			route_num1 = get_route_num(t_ans_num, t_ans, start, sagyo, &temp_length,NULL,ga0);
			/* [g  w胋[g@*/
			if( route_num1 < route_num ) {
				/* blύXi[j@*/
				max = temp_length;
				temp_length -= (temp_length - min) / 2;
			}
			/* [g@@w胋[g@*/
			else if( route_num1 > route_num ) {
			/* blύXi{j@*/
				min = old_temp_length;
				temp_length = old_temp_length + (max - old_temp_length) / 2;
			}
			/* [g@@w胋[g@*/
			else {
				/* blύXi[j@*/
				max = save_temp_length1 = temp_length;
				temp_length -= (temp_length - min) / 2;
			}

		/* blςȂȂiOɂȂjI */
		} while( max - min > EPS ) ;
		if( save_temp_length1 < save_temp_length ) {
			/* m_ans[]Ƀ}`̉ ؂ԍ̑} */
			route_num1 = get_route_num(t_ans_num, t_ans, start, sagyo, &save_temp_length1,m_ans,ga0); CHKB(route_num,route_num1,route_num);
			//memcpy(m_ans,w_ans,(ga0->gap.gene_number+ga0->gap.allele_number-1)*sizeof(*w_ans));
			save_temp_length =  save_temp_length1 ;
			save_start = start;
		}
	}
	/* n_ςĎs@*/
	/* 擪[g̊e_ɂāAvZ */
	/* 
	/* blłnjȂAbl炵Ďs */
	/* ŏ̎bl */
	/* n_́AŏɌ[ĝPɂ_łiׂĂ̓_ɂĎsKvȂj<=@E\I */

	/* t[ */
	//if( w_ans != NULL) free(w_ans);
//quit:	
	if(DBGF[25]) {
		for( i =0; i < ga0->gap.gene_number+ga0->gap.allele_number-1; i++ ) {
			fprintf(logfp,"m_ans[%d]= %d\n",i, m_ans[i] ); fflush(logfp);
		}
		fprintf(logfp,"start(%d) length(%lf)\n",save_start,save_temp_length ); fflush(logfp);
		rcnt = 0;total = 0;
		fprintf(logfp,"route(%d)\n", rcnt++);
		for( i =0; i < ga0->gap.gene_number+ga0->gap.allele_number-2; i++ ) {
			first = m_ans[i]; next = m_ans[i+1];
			if( first >= ga0->gap.gene_number ) {
				total = 0.0;
				fprintf(logfp,"route(%d)\n", rcnt++);
			}
			else if( next >= ga0->gap.gene_number ) continue;
			else {
				s_num = sagyo[first][next];
				total += s_num;
				fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);
			}
		}fflush(logfp);
	}
return(rc);	
}
/*	ID_gatsp_part_make	e[gpf`GÃZbg@GÃp[^ƕϊe[ũZbg
********************************************************************/
int		gatsp_part_make(
int			no,
class GA1	*ga0,
class GA1	*ga2,
int			*m_ans,
int			*h_tbl)
{
	int rc = 0, i, j, k, a, b;
	int	cnt = 0, no1 = 0;

	/* gapRs[΂AƂ͍܂ł̃vO𗬂 */
	memcpy(&ga2->gap, &ga0->gap, sizeof(ga0->gap));

	/* gene_number̃JEg */
	for( i = 0; i < ga0->gap.gene_number+ga0->gap.allele_number-1; i++ ) {
		if( m_ans[i] >= ga0->gap.gene_number) { no1++; continue; }     // Zp[^
		if( no1 > no ) break;
		if( no1 == no ) {
			h_tbl[cnt++] = m_ans[i]; CHKA(0,h_tbl[cnt-1],ga0->gap.gene_number);
		}
	}
	/* VGÄ`qύX */
	ga2->gap.gene_number = cnt;  CHKB(1,cnt,ga0->gap.gene_number);
	ga2->gap.allele_number = 1;
	/* xy_cost̎ˉe */
	if( ga2->xy_cost != NULL ) { free(ga2->xy_cost); ga2->xy_cost= NULL; }
	ga2->xy_cost = (double *)malloc( cnt*cnt * sizeof(*ga2->xy_cost) );
	if( ga2->xy_cost == NULL ){
		printf("memmory error !\n");
		rc = -1;
		goto quit;
	}
	memset( ga2->xy_cost, 0, cnt*cnt * sizeof(*ga2->xy_cost) );
	k = 0;
	for( i = 0; i < cnt; i++ ) {
		a = h_tbl[i]; CHKA(0,a,ga0->gap.gene_number);
		for( j = 0; j < cnt; j++ ) {
			b = h_tbl[j];  CHKA(0,b,ga0->gap.gene_number);
			ga2->xy_cost[k++] = ga0->sagyo[a][b];
		}
	}

	rc = cnt;
quit:
	return(rc);
}

/*	ID_gatsp_part_ret	m_ansɊe[g̕ύX̉߂
********************************************************************/
int	gatsp_part_ret(
int			no,
class GA1	*ga0,
class GA1	*ga2,
int			*m_ans,
int			*h_tbl)
{
	int rc = 0, i, j, a2;
	int	cnt = 0, no1 = 0;

	/* gene_number̃JEg */
	for( i = 0; i < ga0->gap.gene_number+ga0->gap.allele_number-1; i++ ) {
		if( m_ans[i] >= ga0->gap.gene_number) { no1++; continue; }     // Zp[^
		if( no1 == no ) break;
	}
	for( j = 0; j < ga2->gap.gene_number; j++,i++ ) {
		a2 = ga2->ans[j];CHKA(0,a2,ga2->gap.gene_number);
		m_ans[i] = h_tbl[a2];
	}

	return(rc);
}

/*	ID_gaMTSP	TSP̌ʂ[gɕĂ݂
********************************************************************/
int gaMTSP( 
	class GA1	*ga0)
{
//	int rc = 0, *m_ans, pos = -1, cnt = 0, i, j; KS13082chg
	int rc = 0, *m_ans = 0, pos = -1, cnt = 0, i, j;
	//int	i, first, next, *m_ans2;
	double	len, def_num, lval, gval;
	class GA1	ga2;
	class LSTSP lstsp2;
//	int		*h_tbl;     /* e[gGA̕ϊe[u */  KS13082chg
	int		*h_tbl = 0;     /* e[gGA̕ϊe[u */
	int		algotype = 0;  /* f`Ȃ̂Ł@*/
	int		first, next, a, b, max_poi, j1, j2;
	double	s_num, total, max;

	if( (m_ans = (int*) malloc((ga0->gap.gene_number+ga0->gap.allele_number)*sizeof(*m_ans))) == 0 ) goto   quit;
	/* ől[gŏ̕[g */
	len = gamtsp(  ga0->gap.gene_number, ga0->ans, ga0->gap.allele_number, ga0->sagyo, m_ans, ga0 );
	/* Otpf[^t@C̍쐬 */
	out_gdata(ga0,m_ans,ga0->gap.gene_number+ga0->gap.allele_number-1,3,"f`̌ʂe[g֕iő僋[gŏɂȂ悤)");
	/* ϊe[uGÅm */
	if( (h_tbl = (int*) malloc((ga0->gap.gene_number+ga0->gap.allele_number)*sizeof(*h_tbl))) == 0 ) goto   quit;
	ga2.xy_cost = NULL;
	// e[gɂāAsrof`s
	for( i = 0; i < ga0->gap.allele_number; i++ ) {
		/* e[gpf`GÃZbg@GÃp[^ƕϊe[ũZbg */
		if( (rc = gatsp_part_make(i, ga0, &ga2, m_ans, h_tbl)) < 0 )   goto quit;

		/* ɂĂf`s */
		//ga2.fitnes_func = (double (__cdecl *)(int *,int,double *,gaparm *))&GA1::bekiFITNES_VRP;  // problem_typeŕ
		ga2.gap.problem_type = 3;  /* ^Cv@1:TSP 2:ATSP 3:VRP 4: CVRP 5:MTSP 13/02/25 YS */
		/* GAŉ@*/
		ga2.eda_no = 0;
		if ( (rc=gatsp_go( &ga2.gap, algotype, &def_num, &ga2, &gval )) < 0 ) { rc = -1 ; goto  quit; }
		fprintf(logfp, "(%d)gaFunc:=%lf\n",i,gval) ; /* 98/08/24 */
		/* LSŉ */
		lstsp2.sagyo_max = ga2.sagyo_max;
		lstsp2.route_max = ga2.route_max;
		lstsp2.fitness = ga2.fitness;
		if ( (rc=lstsp_go( &ga2.gap, algotype, &def_num, &lstsp2, &ga2, &lval )) < 0 ) { rc = -1 ; goto  quit; }

		/* n_Ti̒Ƃŗւ؂)*/
		total = 0.0; max = 0; max_poi = 0;
		for( j =0; j < ga2.gap.gene_number-1; j++ ) {
			first = ga2.ans[j]; next = ga2.ans[j+1];
			s_num = ga2.sagyo[first][next];
			if( s_num > max ) { max = s_num; max_poi = j+1;}
			total += s_num;
			if(DBGF[20]>0)fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);
		}fflush(logfp);
		first = ga2.ans[j]; next = ga2.ans[0];
		s_num = ga2.sagyo[first][next];
		if( s_num > max ) { max = s_num; max_poi = j+1;}
		if( max_poi >= ga2.gap.gene_number) max_poi -= ga2.gap.gene_number;
		total += s_num;
		if(DBGF[20]>0)fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);

		if(DBGF[20]>0) {
			fprintf(logfp,"̃[g\n");
			total = 0;
			for( j =0; j < ga2.gap.gene_number-1; j++ ) {
				first = h_tbl[j]; next = h_tbl[j+1];
				s_num = ga0->sagyo[first][next];
				total += s_num;
				fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);
			}fflush(logfp);

			fprintf(logfp,"V[g\n");
			total = 0;
			for( j = 0; j < ga2.gap.gene_number-1; j++ ) {
				j1 = j+max_poi; j2 =j+max_poi+1;
				if( j1 >= ga2.gap.gene_number ) j1 -= ga2.gap.gene_number;
				if( j2 >= ga2.gap.gene_number ) j2 -= ga2.gap.gene_number;
				a = ga2.ans[j1]; b = ga2.ans[j2];
				first = h_tbl[a]; next = h_tbl[b];
					s_num = ga0->sagyo[first][next];
					total += s_num;
					fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);
			}fflush(logfp);

			fprintf(logfp,"m߁@V[g\n");
			total = 0;
			for( j =0; j < ga2.gap.gene_number-1; j++ ) {
				first = ga2.ans[j]; next = ga2.ans[j+1];
				s_num = ga2.sagyo[first][next];
				total += s_num;
				fprintf(logfp,"%d -> %d %lf %lf\n",first, next, s_num, total);
			}fflush(logfp);
		}
		/* m_ansɊe[g̕ύX̉߂ */
		gatsp_part_ret(i, ga0, &ga2, m_ans, h_tbl);
	}
	/* Otpf[^t@C̍쐬 */
	out_gdata(ga0,m_ans,ga0->gap.gene_number+ga0->gap.allele_number-1,4,"e[gɍēxf`sros");

quit:
	if( m_ans ) { free(m_ans); m_ans = 0; }  //KS130827add mۂGẢ
	if( h_tbl ) { free(h_tbl); h_tbl = 0; }  //KS130827add
	return(rc);
}

