/*
 * file		: gatsp.c
 * system	: `ASYga1()̃eXgp
 * function	: Z[X}̗
 * auther	: 2012.12.14 Y.Shibasaki
 */
//#include	<stdafx.h>
#pragma warning(disable:4996)

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<malloc.h>
#include	<memory.h>
#include	<time.h>
#include	"ssc.h"
//#include	"gaparm.h"
//#define _USE_MATH_DEFINES  // M_PÎ
#include <math.h>
//#define M_PI	   3.14159265358979323846
#include "ga1.h"
//#include "gatsp.h"
/****************/

/*	ID_chk_same_point	_ʂĂȂ̃`FbN
********************************************************************/
int chk_same_point_tsp(
	int	*path,
	int	num,
	int *chk)
{
	int	rc = 0, i, j, chk_No;

	chk_No = chk[0];
	for( i = 0; i < num; i++ ) {
		j = path[i];		CHKA(0,j,num); CHKB(chk_No,chk[j],chk_No);
		chk[j]++;
	}
	return(rc);
}
/*	ID_Eval	SsԂԂ
********************************************************************/
double Eval( /*n_job, n_mcn, sagyo, ans, mcn )	/* łKvȊ֐ */
	int		n_job,
	int		n_mcn,
	register double	**sagyo,   // ZFd̎dł́A͒i莞
	register int 	*ans,
	register	double *mcn )	 // ZFd̎dł́AɍƎԂĂ邩
{
	register int 	i, first, next;
//	register long	max;
	register	double	total = 0.0;
/* machine loading and max selection */
	// TODO
	//memset( mcn, 0, sizeof(*mcn) * n_mcn );
	//	CHKB ( 1,gap.locus_unique,1 ) ;
	for ( i = 0; i < n_job	; i++ ) {
		first = ans[i];			//CHKA(0,first,gap.gene_number);
		if( i+1 == n_job ) 	next = ans[0];
		else							next = ans[i+1];
			//CHKA(0,next,gap.gene_number);
		total += sagyo[first][next];
		//CHKAD(0.1,sagyo[first][next],total_sagyo);
	}
	CHKBD(0.01, total,total);
	return( total ) ;
}

/*	ID_SAGYOinit2	TSPLIBǂݍ񂾃f[^ƂɃZbg
********************************************************************/
static int SAGYOinit2( //len )
	int	len,
	class GA1 *ga0)
{
	int		i ;
	for( i=0 ; i<len ; i++ ) {
		ga0->sagyo[i] = &ga0->xy_cost[len*i] ;
		CHKBD(0.0,ga0->sagyo[i][i], 0.0);
	}
	return( 0 );
}
/*	ID_tspINIT	TSPp̃GAAsrokhaCuqokhãf[^Zbg
********************************************************************/
static int tspINIT(class GA1 *ga0)
{
	double	dwk;
	int 	i, j;
	int		gene_number, allele_number, gener_gap;

	gene_number = ga0->gap.gene_number;
	allele_number = ga0->gap.allele_number;
	gener_gap = ga0->gap.gener_gap;
	if( ga0->ans == NULL ) ga0->ans    = (int*) malloc( gene_number*sizeof(*ga0->ans) );
	if( ga0->allele == NULL ) ga0->allele = (int*) malloc( gene_number*sizeof(*ga0->allele) );
	if( ga0->rank == NULL ) ga0->rank	= (double*) malloc( ga0->gap.popul_size*sizeof(*ga0->rank) );
//KS130206CHG	rank   = (double*) malloc( gene_number*sizeof(*rank) );
	if( ga0->sagyo == NULL ) ga0->sagyo  = (double**)malloc( (gene_number+allele_number)*sizeof(*ga0->sagyo) );
	if( ga0->mcn == NULL ) ga0->mcn    = (double*)malloc( allele_number*sizeof(*ga0->mcn) );
	if( ga0->chk == NULL ) ga0->chk    = (int*) malloc( gene_number*sizeof(*(ga0->chk)) ); // TSP _̏dCHKp 2012.01.09
	if( ga0->route_num == NULL ) ga0->route_num = (double*) malloc( allele_number*sizeof(*ga0->route_num) ); // VRP e[gƂ̍v 2012.02.22

	if( ga0->ans == NULL || ga0->allele == NULL || ga0->rank == NULL || ga0->sagyo == NULL
	 || ga0->mcn == NULL || ga0->chk == NULL || ga0->route_num == NULL ) goto err1;
	memset(ga0->chk, 0, gene_number*sizeof(*ga0->chk) );
	memset( ga0->ans, 0, sizeof(int) * gene_number ) ;
	//SAGYOinit( gene_number ) ;	// f[^
	// VRP CVRPf[^́Ałallele_numberǉ */
	if( ga0->gap.problem_type == VRP ||  ga0->gap.problem_type == CVRP) SAGYOinit2( gene_number,ga0 ) ;		// TSPLIBf[^
	else SAGYOinit2( gene_number+allele_number-1,ga0 ) ;		// TSPLIBf[^
	if( gener_gap <= 0 || gener_gap > ga0->gap.popul_size )
		ga0->gap.gener_gap = ga0->gap.popul_size;
	ga0->gap.rank = ga0->rank;
	ga0->total_sagyo = 0.0; 		   //es̍ől̍v
	if(DBGF[20]) fprintf(logfp,"*** sagyo ***\n");
	for( i = 0 ; i < gene_number ; ++i ) {
		dwk = 0.0;
		for( j = 0 ; j < gene_number ; ++j ) {
			if(DBGF[20]) fprintf(logfp,"%lf,",ga0->sagyo[i][j]);
			if( i == j ) { CHKBD(0.0,ga0->sagyo[i][j],0.0); continue; }
//			total_sagyo += sagyo[i][j]; 			   //NT130207del
			if( dwk < ga0->sagyo[i][j] ) dwk = ga0->sagyo[i][j]; //NT130207add
		}
		ga0->total_sagyo += dwk;				//NT130207add
		if(DBGF[20]) fprintf(logfp,"\n");
		ga0->allele[i] = allele_number ;	// ???
//		rank[i] = dwk;			//KS130206CHG						// ???
//		dwk *= 0.7;
	}
	dwk = 10000.0;
	for( i = 0 ; i < ga0->gap.popul_size ; ++i ) {	//KS130206CHG
		ga0->rank[i] = dwk;									// ???
		dwk *= 0.7;
	}
	if(DBGF[20]) fprintf(logfp,"total_sagyo(%lf)\n", ga0->total_sagyo);
	return( 0 );
err1: printf( "**** cannot allocate ****\n" ); fflush(stdout); //KS130918 fflush ǉ
	return( -1 ) ;
}

/*	ID_tspFINAL	I@GẢ gp
********************************************************************/
int tspFINAL(class GA1 *ga0)
{
	if( ga0->ans ) free( (char*)ga0->ans ), ga0->ans = NULL;
	if( ga0->allele ) free( (char*)ga0->allele ), ga0->allele = NULL;
	if( ga0->rank ) free( (char*)ga0->rank ), ga0->rank = NULL;
	if( ga0->sagyo ) free( (char*)ga0->sagyo ), ga0->sagyo = NULL;
	if( ga0->mcn ) free( (char*)ga0->mcn ), ga0->mcn = NULL;
	if( ga0->chk ) free( (char*)ga0->chk ), ga0->chk = NULL;
	if( ga0->route_num ) free( (char*)ga0->route_num ), ga0->route_num = NULL;
	if( ga0->xy_cost ) free( (char*)ga0->xy_cost ), ga0->xy_cost = NULL;
	// ga0->c̃t[ց@eɂĂĂ݂邽
	//gaFINAL( ) ;	RgɂAړs@TODO

	return( 0 );
}

 int huristic( /*n_job, n_mcn, sagyo, allele, ans ) */
	int		n_job,
	int		n_mcn,
	double	**sagyo ,
	int		allele[],
	int		ans[])
{
	int 	i, j, first, next, r;
	double	min;
	 char *endf=NULL ;

	if ( !endf ) if( (endf = (char *)malloc( sizeof(*endf) * n_job )) == NULL ) goto err1 ;
	memset( endf, 0, sizeof(*endf)*n_job ) ;
	/* ŏsԌo */
	first = next = -1;
	min = -1;
	for( i = 0; i < n_job; i++ ) {
		for( j = 0; j < n_job; j++ ) {
			if( i == j ) continue;
			if( min == -1 || sagyo[i][j] < min ) {
				first = i; next =j;
				min = sagyo[i][j];
			}
		}
	}

	/* [gt@*/
	ans[0] = first;
	ans[1] = next;
	endf[first] = 1;
	endf[next] = 1;
	for( r = 2; r < n_job; r++ ) {
		i = next;
		min = -1;
		for( j = 0; j < n_job; j++ ) {
			if( i == j || endf[j] == 1) continue;
			if( min == -1 || sagyo[i][j] < min ) {
				first = i; next =j;
				min = sagyo[i][j];
			}
		}CHKAD(0,min,min);
		ans[r] = next;
		endf[next] = 1;
	}
	free( endf );
	return( 0 ) ;
err1: printf( "**** cannot allocate ****\n" );
	return( -1 ) ;
}
/*	ID_gaINITMK2	𐶐2(_uȂ̈`q𔭐)
********************************************************************/
static int gaINITMK2( //w_gcro, allele, len, popul_size )
	int 	**w_gcro ,
	int 	*allele  ,
	int 	len 	  ,
	int 	popul_size,
	class GA1 *ga0)
{
	int 	rc=0, i, j ;
	int		val, pos ;
	 int *endf=NULL ;
	 int *endf2=NULL ;

	if(DBGF[20]) fprintf(logfp,"gaINITMK2 ===w_gcro(%lx)allele(%lx)len(%d)popul_size(%d)\n",w_gcro,allele,len, popul_size ) ;
	if ( !endf	) endf	= (int*)malloc( sizeof(*endf) * len ) ;
	if ( !endf2 ) endf2 = (int*)malloc( sizeof(*endf2) * len ) ;
	for ( i=0 ; i<popul_size ; i++ ) {
		memset( endf , 0, sizeof(*endf )*len ) ;
		memset( endf2, 0, sizeof(*endf2)*len ) ;
		memset( &w_gcro[i][0], 0, sizeof(w_gcro[i][0]) * len ) ;
		for( j = 0; j < len; j++ ) {
			endf[j] = j;
		}
		for( j = 0; j < len; j++ ) {
			val = (int)(ga0->RANDsk() * (len - j));
//			w_gcro[i][j] = endf[val] ; //QsƂ̍ŝǂłǂ
			pos = endf[val];
			w_gcro[i][pos] = j ;
			endf[val] = endf[len - j - 1];
		}
		//`FbN
		for( j = 0; j < len; j++ ) {
			val = w_gcro[i][j] ;	CHKA(0, val, len); CHKB(0, endf2[val], 0);
			endf2[val] = 1 ;
		}
		if(DBGF[20]>0) { // IMADAKE >=0 2015.11.27 YS
			fprintf(logfp,"#%d:",i);
			for ( j=0 ; j<len ;j++ )
				fprintf(logfp,"%d ",w_gcro[i][j]);
			fprintf(logfp,"\n");
		}
	}
	free( endf ), endf = NULL ;
	free( endf2 ), endf2 = NULL ;
	/* 擪ɒʔԂ̉Ă݂ (MTSP̊e[gɂĂf`sƂ̏ɂj2013.05.29 YS @*/
	for( pos = 0; pos < len; pos++ ) {
		w_gcro[0][pos] = pos ;
	}
	return( rc ) ;
}


/*	ID_tsplibRead	TSPLIB`̃t@Cf[^ǂ VRPLIB`ǉ
********************************************************************/
int	tsplibRead(    // 1-4:ǂݍ񂾃t@C̃^Cv 0:ɓ͍ <0:G[
char *fname,
struct gaparm	*gparm,
class GA1 *ga0)
{
	int		rc = 0, i, j;
	FILE	*fp = NULL;
	char	buf[512], key[256];
	char	*p, *poi;
	char probname[ATSP_NAME_MAX+1];
	int	type = 0, etype = -1, eformat = UNKNOWN_FORMAT;
	char	comment[256];
//	 char	save_fname[256] = "";
	static char	save_fname[256] = "";  //KS130820chg t@CۑȂB
	int		n = -1, ncoord = -1, m = -1;
	char	value[128];
	char 	*token;
	double	*xcoord, *ycoord, *zcoord;
	double	xd, yd, zd, tmpd;
	double	deg, min, q1,q2,q3,q4,q5;
	double	lat_i, lat_j, long_i, long_j;
	char	tail_st[256], head_st[256], top_char = '\0';
	int		max_size;
	FILE	*fp2;
	int		m2;
	char	fname2[256];

	/* ɓǂݍݍς̃f[^Ȃǂ܂Ȃ 2013.01.25 */
	if( strcmp(fname,save_fname) == 0 )    goto quit;
	if( (fp = fopen(fname,"r")) == NULL ) {
		printf("t@C(%s)I[vł܂\n",fname);
		rc = -1; goto quit;
	}
	ga0->xcoord = NULL;   // 2013.06.10 YS
	ga0->ycoord = NULL;
	ga0->xy_cost = NULL;
	comment[0] = '\0'; //2013.07.31 YS

	while( fgets(buf,256,fp) != NULL ){
		/* remove : delimiter from buf */
		for(p = buf; *p != '\0'; ++p)
			if(*p == ':') *p = ' '; /* cut off the : delimiter */
			
		if(sscanf(buf, "%s", key) == EOF)	 continue; /* empty buf */
		p = buf + strlen(key);
		/* remove leeding whitespaces */
		while(*p == ' ' || *p == '\t' || *p == '\r' || *p == '\n')
			++p;
		/* remove trailing whitespaces */
		for(i=strlen(p) - 1; i >= 0 && (*(p + i) == ' ' || *(p + i) == '\t' || *(p + i) == '\r' || *(p + i) == '\n'); --i)
			*(p + i) ='\0';
		/* probname */
		if(!strcmp(key, "NAME")) {
			strncpy(probname, p, 256);
			probname[256]='\0';
			continue;
		}
		/* prob type */
		if(! strcmp(key, "TYPE")) {
			if(sscanf(p, "%s", value) == EOF)		goto   read_error;
			if(! strcmp(value, "ATSP"))				type = ATSP;
			else if(! strcmp(value, "TSP"))			type = TSP;
			else if(! strcmp(value, "VRP"))			type = VRP;
			else if(! strcmp(value, "CVRP"))		type = CVRP;
			else if(! strcmp(value, "MTSP"))		type = MTSP;  // 2013.04.12 YS Add TSPsɁA[gɕ
				
			if(type == UNKNOWN_PROB_TYPE)			goto   read_error; /* we can only handle ATSP or TSP problems */
			if((type == VRP || type == CVRP || type == MTSP) && comment[0] != '\0') { // 2013.07.31 YS
				if((poi = strstr(comment,"trucks")) != NULL ){ /* VRPLIBΉ 130218 YS */
					/* gbNalleleɃZbg */
					if( (gparm->allele_number = atoi(poi+7)) <= 0 ) { CHKA(-1, -1, -1); goto	   read_error; }
				}
				if((poi = strstr(comment,"Optimal value")) != NULL ){ /* VRPLIBΉ 130218 YS */
					/* œKloptimalValueɃZbg */
					if( (ga0->optimalValue = atof(poi+14)) <= 0 )	{ CHKA(-1, -1, -1); goto	   read_error; }
				}
			}
			else { // ga1_def.txt ɂPȊOݒłĂ܂̂ŁAPɐݒ肷 2016.01.05 Y.S
				gparm->allele_number = 1;
			}
			continue;
		}
		/* comment */
		/*if((type == VRP || type == CVRP || type == MTSP ) && (! strcmp(key, "COMMENT"))) COMMENTs̕@*/
		if( ! strcmp(key, "COMMENT")) {
			strcpy(comment, p);
			if( (type == VRP || type == CVRP || type == MTSP) && comment[0] != '\0') { // 2013.07.31 YS
				if((poi = strstr(comment,"trucks")) != NULL ){ /* VRPLIBΉ 130218 YS */
					/* gbNalleleɃZbg */
					if( (gparm->allele_number = atoi(poi+7)) <= 0 ) { CHKA(-1, -1, -1); goto	   read_error; }
				}
				if((poi = strstr(comment,"Optimal value")) != NULL ){ /* VRPLIBΉ 130218 YS */
					/* œKloptimalValueɃZbg */
					if( (ga0->optimalValue = atof(poi+14)) <= 0 )	{ CHKA(-1, -1, -1); goto	   read_error; }
				}
			}
			else { //ƓłȂƂȂ̂Œǉ 20160112KS
				gparm->allele_number = 1;
			}
			continue;
		}
		/* dimension */
		if(! strcmp(key, "DIMENSION")) {
			if(sscanf(p, "%d", & n) == EOF)			goto   read_error;
			gparm->popul_size = (int)(n*2.8);
			gparm->gene_number = n;
			CHKB(1,gparm->allele_number,gparm->gene_number);
			m = n + gparm->allele_number - 1; /* gbNZp[^Ƃēo^ */
			continue;
		}
		/* edge weight format */
		if(! strcmp(key, "EDGE_WEIGHT_TYPE")) {
			if(sscanf(p, "%s", value) == EOF)		goto   read_error;
			if(! strcmp(value, "EXPLICIT"))	{	etype = EXPLICIT;	if(ncoord < 0)	ncoord = 0;	continue; }
			if(! strcmp(value, "EUC_2D"))	{	etype = EUC_2D;		if(ncoord < 0)	ncoord = 2;	continue; }
			if(! strcmp(value, "EUC_3D"))	{	etype = EUC_3D;		if(ncoord < 0)	ncoord = 3;	continue; }
			if(! strcmp(value, "MAX_2D"))	{	etype = MAX_2D;		if(ncoord < 0)	ncoord = 2;	continue; }
			if(! strcmp(value, "MAX_3D"))	{	etype = MAX_3D;		if(ncoord < 0)	ncoord = 3;	continue; }
			if(! strcmp(value, "MAN_2D"))	{	etype = MAN_2D;		if(ncoord < 0)	ncoord = 2;	continue; }
			if(! strcmp(value, "MAN_3D"))	{	etype = MAN_3D;		if(ncoord < 0)	ncoord = 3;	continue; }
			if(! strcmp(value, "CEIL_2D"))	{	etype = CEIL_2D;	if(ncoord < 0)	ncoord = 2;	continue; }
			if(! strcmp(value, "GEO"))		{	etype = GEO;		if(ncoord < 0)	ncoord = 2;	continue; }
			if(! strcmp(value, "GEOM"))		{	etype = GEOM;		if(ncoord < 0)	ncoord = 2;	continue; }
			if(! strcmp(value, "ATT"))		{	etype = ATT;		if(ncoord < 0)	ncoord = 2;	continue; }
			// crystal problems not implemented yet
			/*
			if(! strcmp(value, "XRAY1"))	{	etype = XRAY1;		continue;			}
			if(! strcmp(value, "XRAY2"))	{	etype = XRAY2;		continue;			}
			*/
			/* unknown norm type */
			goto   read_error;
		} /* end edge weight type */

		/* edge weight format */
		if(! strcmp(key, "EDGE_WEIGHT_FORMAT"))	{
			if(sscanf(p, "%s", value) == EOF)		goto   read_error;
			if(! strcmp(value, "FULL_MATRIX"))		{	eformat = FULL_MATRIX;		continue;	}
			if(! strcmp(value, "UPPER_ROW"))		{	eformat = UPPER_ROW;		continue;	}
			if(! strcmp(value, "LOWER_ROW"))		{	eformat = LOWER_ROW;		continue;	}
			if(! strcmp(value, "UPPER_DIAG_ROW"))	{	eformat = UPPER_DIAG_ROW;	continue;	}
			if(! strcmp(value, "LOWER_DIAG_ROW"))	{	eformat = LOWER_DIAG_ROW;	continue;	}
			if(! strcmp(value, "UPPER_COL"))		{	eformat = UPPER_COL;		continue;	}
			if(! strcmp(value, "LOWER_COL"))		{	eformat = LOWER_COL;		continue;	}
			if(! strcmp(value, "UPPER_DIAG_COL"))	{	eformat = UPPER_DIAG_COL;	continue;	}
			if(! strcmp(value, "LOWER_DIAG_COL"))	{	eformat = LOWER_DIAG_COL;	continue;	}
			if(! strcmp(value, "FUNCTION"))			{	eformat = FUNCTION;			continue;	}
			CHKA(0,0,0); goto                              read_error;   //KS20150721add
		}
		/* number of coordinates assosiated with each node */
		if( ! strcmp(key, "NODE_COORD_TYPE"))	{
			if(sscanf(p,"%s", value) == EOF)		goto   read_error;
			if(! strcmp(value, "TWOD_COORDS"))		{	ncoord = 2;		continue;	}
			if(! strcmp(value, "THREED_COORDS"))	{	ncoord = 3;		continue;	}
			if(! strcmp(value, "NO_COORDS"))		{	ncoord = 0;		continue;	}
		}
		/* node coordinates */
		if(! strcmp(key, "NODE_COORD_SECTION"))
		{
			if(n <= 0)								goto   read_error;
			if(etype == UNKNOWN_TYPE)				goto   read_error;
			//xcoord = (double *)malloc( n * sizeof(*xcoord) ); alleleŎĂ
			if((xcoord = (double *)malloc( m * sizeof(*xcoord) )) == NULL)  { rc = -1; goto quit; }
			memset(xcoord,0, m * sizeof(*xcoord));
			//ycoord = (double *)malloc( n * sizeof(*ycoord) );
			if((ycoord = (double *)malloc( m * sizeof(*ycoord) )) == NULL)  { rc = -1; goto quit; }
			memset(ycoord,0, m * sizeof(*ycoord));
			if(ncoord == 3){
				//zcoord = (double *)malloc( n * sizeof(*zcoord) );
				if((zcoord = (double *)malloc( m * sizeof(*zcoord) )) == NULL)  { rc = -1; goto quit; }
				memset(zcoord,0, m * sizeof(*zcoord));
			}
			token = NULL;
			for(i = 0; i < n; ++i)	{
				//KS20150721chg
				char sx[64], sy[64], sz[64];
				if( (fscanf(fp, "%d", &j)) == EOF ) goto   read_error;
				if( (fscanf(fp, "%s", sx)) == EOF ) goto   read_error;
				if( (fscanf(fp, "%s", sy)) == EOF ) goto   read_error;
				xcoord[j-1] = atof(sx);	/* get x */
				ycoord[j-1] = atof(sy);	/* get y */
//fprintf(logfp,"j-1(%d)X(%lf)Y(%lf)", j-1, xcoord[j-1], ycoord[j-1]);
				if(ncoord == 3) {
					if( (fscanf(fp, "%s", sz)) == EOF ) goto   read_error;
					zcoord[j-1] = atof(sz); /* get z */
//fprintf(logfp,"Z(%lf)", zcoord[j-1]);
				}
//fprintf(logfp,"\n"); fflush(logfp);

			}
			if(etype == EXPLICIT)	{
				//freeBufferArrayNull(scip, & xcoord);
				//freeBufferArrayNull(scip, & ycoord);
				//if(ncoord == 3)
  				//	freeBufferArrayNull(scip, & zcoord);
				continue;
			}
			/* now construct distances from node coordinates, if needed */
			/* these calcuations correspondents to the functions given in
			 * TSPLIB 95 by Reinelt
			 */
			//m = n + gap.allele_number - 1; /* gbNZp[^Ƃēo^ */
			/*xy_cost = (double *)malloc( n*n * sizeof(*xy_cost) );*/
			// mۃTCYhmsQl`w𒴂āAmȒlnȂP[X̑Ή@max_size:m̍ő吔
			max_size = (int)sqrt((double)INT_MAX / sizeof(*ga0->xy_cost));
			if( m >= max_size ) {  //??? bZ[Wς
//KS20150721chg	printf("mۂł܂(%d)\n",m*m * sizeof(*ga0->xy_cost));
//				fprintf(logfp,"mۂł܂(%d)\n",m*m * sizeof(*ga0->xy_cost));
				printf("mۃTCYől𒴂܂(%d)\n",m);
				fprintf(logfp,"mۃTCYől𒴂܂(%d)\n",m);
				rc = -1;
				goto quit;
			}
			ga0->xy_cost = (double *)malloc( m*m * sizeof(*ga0->xy_cost) );
			if( ga0->xy_cost == NULL ) {
				printf("mۂł܂(%d)\n",m*m * sizeof(*ga0->xy_cost));
				fprintf(logfp,"mۂł܂(%d)\n",m*m * sizeof(*ga0->xy_cost));
				rc = -1;
				goto quit;
			}
			ga0->xcoord = xcoord;	// 2013.06.10 YS
			ga0->ycoord = ycoord;	// 2013.06.10 YS
			memset( ga0->xy_cost, 0, m*m * sizeof(*ga0->xy_cost) );
			for(i=0; i < n; ++i){
				for(j=0; j < n; ++j)	{
					switch(etype)	{
					case EUC_2D:	xd = xcoord[i] - xcoord[j];
									yd = ycoord[i] - ycoord[j];
									/*ga0->xy_cost[i*n+j] = NINT(sqrt(xd * xd + yd * yd));*/
									ga0->xy_cost[i*m+j] = NINT(sqrt(xd * xd + yd * yd));
									break;
					case CEIL_2D:	xd = xcoord[i] - xcoord[j];
									yd = ycoord[i] - ycoord[j];
									/*ga0->xy_cost[i*n+j] = ceil(sqrt(xd * xd + yd * yd));*/
									ga0->xy_cost[i*m+j] = ceil(sqrt(xd * xd + yd * yd));
									break;
					case ATT:		xd = xcoord[i] - xcoord[j];
									yd = ycoord[i] - ycoord[j];
									/*ga0->xy_cost[i*n+j] = ceil(sqrt((xd * xd + yd * yd)/10.0));*/
									ga0->xy_cost[i*m+j] = ceil(sqrt((xd * xd + yd * yd)/10.0));
									break;
					case EUC_3D:	xd = xcoord[i] - xcoord[j];
									yd = ycoord[i] - ycoord[j];
									zd = zcoord[i] - zcoord[j];
									/*ga0->xy_cost[i*n+j] = NINT(sqrt(xd * xd + yd * yd + zd * zd));*/
									ga0->xy_cost[i*m+j] = NINT(sqrt(xd * xd + yd * yd + zd * zd));
									break;
					case MAN_2D:	xd = fabs(xcoord[i] - xcoord[j]);
									yd = fabs(ycoord[i] - ycoord[j]);
									/*ga0->xy_cost[i*n+j] = NINT(xd + yd);*/
									ga0->xy_cost[i*m+j] = NINT(xd + yd);
									break;
					case MAN_3D:	xd = fabs(xcoord[i] - xcoord[j]);
									yd = fabs(ycoord[i] - ycoord[j]);
									zd = fabs(zcoord[i] - zcoord[j]);
									/*ga0->xy_cost[i*n+j] = NINT(xd + yd + zd);*/
									ga0->xy_cost[i*m+j] = NINT(xd + yd + zd);
									break;
					case MAX_2D:	xd = fabs(xcoord[i] - xcoord[j]);
									yd = fabs(ycoord[i] - ycoord[j]);
									/*ga0->xy_cost[i*n+j] = NINT(xd < yd ? yd : xd);*/
									ga0->xy_cost[i*m+j] = NINT(xd < yd ? yd : xd);
									break;
					case MAX_3D:	xd = fabs(xcoord[i] - xcoord[j]);
									yd = fabs(ycoord[i] - ycoord[j]);
									zd = fabs(zcoord[i] - zcoord[j]);
									tmpd = xd < yd ? yd : xd;
									/*ga0->xy_cost[i*n+j] = NINT(tmpd < zd ? zd : tmpd);*/
									ga0->xy_cost[i*m+j] = NINT(tmpd < zd ? zd : tmpd);
									break;
					case GEO: /* convert DDD.MM to longitude and latitude */
									deg = floor(xcoord[i]);
									min = xcoord[i] - deg;
									lat_i = GEO_PI * (deg + 5.0 * min / 3.0 ) / 180.0;

									deg = floor(ycoord[i]);
									min = ycoord[i] - deg;
									long_i = GEO_PI * (deg + 5.0 * min / 3.0 ) / 180.0;
				 												deg = floor(xcoord[j]);
									min = xcoord[j] - deg;
									lat_j = GEO_PI * (deg + 5.0 * min / 3.0 ) / 180.0;
																deg = floor(ycoord[j]);
									min = ycoord[j] - deg;
									long_j = GEO_PI * (deg + 5.0 * min / 3.0 ) / 180.0;

									q1 = cos(long_i - long_j);
									q2 = cos(lat_i - lat_j);
									q3 = cos(lat_i + lat_j);

									/*ga0->xy_cost[i*n+j] = floor(6378.388 * acos(0.5 * ((1.0 + q1)*q2 - (1.0 - q1) * q3)) + 1.0);*/
									ga0->xy_cost[i*m+j] = floor(6378.388 * acos(0.5 * ((1.0 + q1)*q2 - (1.0 - q1) * q3)) + 0.999);
									//ga0->xy_cost[i*m+j] = floor(6378.388 * acos(0.5 * ((1.0 + q1)*q2 - (1.0 - q1) * q3)) + 1.0);
									break;
					case GEOM:			lat_i = M_PI * xcoord[i] / 180.0;
									lat_j = M_PI * xcoord[j] / 180.0;
									long_i = M_PI * ycoord[i] / 180.0;
									long_j = M_PI * ycoord[j] / 180.0;
									q1 = cos (lat_j) * sin(long_i - long_j);
									q3 = sin((long_i - long_j)/2.0);
									q4 = cos((long_i - long_j)/2.0);
									q2 = sin(lat_i + lat_j) * q3 * q3 - sin(lat_i - lat_j) * q4 * q4;
									q5 = cos(lat_i - lat_j) * q4 * q4 - cos(lat_i + lat_j) * q3 * q3;
									/*ga0->xy_cost[i*n+j] = (int) (6378388.0 * atan2(sqrt(q1*q1 + q2*q2), q5) + 1.0);*/
									//ga0->xy_cost[i*m+j] = (int) (6378388.0 * atan2(sqrt(q1*q1 + q2*q2), q5) + 1.0);
									ga0->xy_cost[i*m+j] = (int) (6378388.0 * atan2(sqrt(q1*q1 + q2*q2), q5) + 0.999);
									break;
					default:
								CHKA(-1,-1,-1);
								break;

					} /* end switch */
					//if( i != j) CHKBD(0.1,ga0->xy_cost[i*m+j],ga0->xy_cost[i*m+j]);// IMADAKE
				} /* end distance calculation */
			}
			/* free temporay node coords buffers */
			//free( xcoord);	 // 2013.06.10 YS
			//free( ycoord);	 // 2013.06.10 YS
			if(ncoord == 3)
			free( zcoord);
			continue;
		} /* end NODE_COORD_SECTION */
		if( ! strcmp(key, "EDGE_WEIGHT_SECTION"))	{
			if(etype != EXPLICIT)	 		goto   read_error;
			if(n <= 0)						goto   read_error;
			/* allocate space for distances */
			/*ga0->xy_cost = (double *)malloc( n*n * sizeof(*ga0->xy_cost) );*/
			ga0->xy_cost = (double *)malloc( m*m * sizeof(*ga0->xy_cost) );
			if( ga0->xy_cost == NULL ) {
				printf("mۂł܂(%d)\n",m*m * sizeof(*ga0->xy_cost));
				rc = -1;
				goto quit;
			}
			memset( ga0->xy_cost, 0, m*m * sizeof(*ga0->xy_cost) );
			token = NULL;
			switch(eformat)	{
				case UNKNOWN_FORMAT : goto   read_error;
				case FULL_MATRIX:
	  				for(i=0; i < n; ++i)
	  					for(j=0; j < n; ++j) {
							/* init parsing */
							//KS20150721chg
							if( (fscanf(fp, "%s", buf)) == EOF ) goto   read_error;
							ga0->xy_cost[i*m+j] = atof(buf);
							ga0->xy_cost[j*m+i] = atof(buf);
//fprintf(logfp,"i(%d)j(%d)i*m+j(%d)j*m+i(%d)xy_cost(%lf)\n", i, j, i*m+j, j*m+i, ga0->xy_cost[i*m+j]); fflush(logfp);					
						}
	  				break;
				case UPPER_ROW:
				case UPPER_COL: /* symmetric */
	  				for(i=0; i < n; ++i) {
	  					for(j=i+1; j < n; ++j) 	{
							if( (fscanf(fp, "%s", buf)) == EOF ) 
								goto   read_error;
							ga0->xy_cost[i*m+j] = atof(buf);
							ga0->xy_cost[j*m+i] = atof(buf);
//fprintf(logfp,"i(%d)j(%d)i*m+j(%d)j*m+i(%d)xy_cost(%lf)\n", i, j, i*m+j, j*m+i, ga0->xy_cost[i*m+j]); fflush(logfp);		
  						}
	  				}
	  				break;
				case LOWER_ROW:
				case LOWER_COL: /* symmetric */
					for(i=0; i < n; ++i)	{
	  					for(j=0; j < i; ++j)	{
							if( (fscanf(fp, "%s", buf)) == EOF ) goto   read_error;
							ga0->xy_cost[i*m+j] = atof(buf);
							ga0->xy_cost[j*m+i] = atof(buf);
//fprintf(logfp,"i(%d)j(%d)i*m+j(%d)j*m+i(%d)xy_cost(%lf)\n", i, j, i*m+j, j*m+i, ga0->xy_cost[i*m+j]); fflush(logfp);
	  					}
	  				}
	  				break;
				case UPPER_DIAG_ROW:
				case UPPER_DIAG_COL: /* symmetric */
					for(i=0; i < n; ++i)
	  					for(j=i; j < n; ++j)	{
							if( (fscanf(fp, "%s", buf)) == EOF ) goto   read_error;
							ga0->xy_cost[i*m+j] = atof(buf);
							ga0->xy_cost[j*m+i] = atof(buf);
//fprintf(logfp,"i(%d)j(%d)i*m+j(%d)j*m+i(%d)xy_cost(%lf)\n", i, j, i*m+j, j*m+i, ga0->xy_cost[i*m+j]); fflush(logfp);
						}
	  				break;
				case LOWER_DIAG_ROW:
				case LOWER_DIAG_COL: /* symmetric */
					for(i=0; i < n; ++i){
	  					for(j=0; j <= i; ++j)	{
							if( (fscanf(fp, "%s", buf)) == EOF ) goto   read_error;
							ga0->xy_cost[i*m+j] = ga0->xy_cost[j*m+i] = atof(buf);
//fprintf(logfp,"i(%d)j(%d)i*m+j(%d)j*m+i(%d)xy_cost(%lf)\n", i, j, i*m+j, j*m+i, ga0->xy_cost[j*m+i]) ;fflush(logfp);
	  					}
						CHKBD(0.0,ga0->xy_cost[i*m+i] ,0.0);
					}
	  				break;
				default:
					CHKA(-1,-1,-1);
					break;
			} /* end switch */
		}/* end edge weight section */
		/* CAPACITY(gbN̍őύڗ) ͎gȂ̂œǂݔ΂ */
		/* DEMAND_SECTION(zvʂ̋K) ͎gȂ̂œǂݔ΂ */
		/* DEPOT_SECTION(zZ^[̋K) ͎gȂ̂œǂݔ΂ */
	}
	fclose(fp);
	/*** DEBUG ***/
	/* ǂݍ񂾃f[^oĐ͂Ăm߂Ă݂@*/
	sprintf(fname2,"%s.dbg",fname);
	if( (fp2 = fopen(fname2,"w")) == NULL ) {
		printf("t@C(%s)I[vł܂\n",fname2);
		rc = -1; goto quit;
	}
	fprintf(fp2,"fobOp@ǂݍ݃f[^̏o\n");
	m2 = n;
	for( i = 0; i < n; i++ ) {
		for( j = i+1; j < n; j++ ) {
			fprintf(fp2," %7.0lf",ga0->xy_cost[i*m+j]);
		}
		fprintf(fp2,"\n");
		m2--;
	}
	fclose(fp2);

	strcpy(save_fname,fname);
	rc = type; CHKB(1,type,5);// ǂݍ񂾃t@C̃^Cv
quit:
	if( fp ) fclose(fp);
	return(rc);
read_error:
	rc = READERROR;
	goto											 quit;
}
extern int Gap_print(
	FILE	*fp,
	struct gaparm	*gap0);

/*	ID_Result_print	t@Co œK̃t@CȂÃt@CƂُ̍o
********************************************************************/
 int Result_print(	 /* rc =1:œK̃t@C@rc=0:œK̃t@CȂ */
	int		*ans,
	double	sagyo_max,
	double	fitness,
	struct	gaparm	*gap,
	char	*fname,
	char	*fname_opt,
	double	*def_num,
	//double	(*fitnes_func)(int*, int, double *, struct gaparm *, class GA1 *),
	class GA1 *ga0)		/* (i)KxvZ֐ */

{
 	int 	rc=0, i, dim, num, sep_no;
	char	*poi, *token;
	double	fitness2, sagyo_max2, route_max = 0.0; // 2015.11.20 YS Add
	char	ofname[256], buf[512];
	FILE	*fp = NULL, *fp2 = NULL;
	int		*ans2 = NULL;
//	int		first, next;
		char	*problem_type_st[] = {"", "TSP", "ATSP", "VRP", "CVRP", "MTSP"};
	char	eda_st[10];
	time_t timer;
	struct tm *local;

#ifdef TEST
	int		t_i;
#endif
	/* o͑O`FbN */
	/* _ʂĂȂH */
	chk_same_point_tsp(ans, gap->gene_number, ga0->chk );
	/* ʏo̓t@CɎ}Ԃ@ieXgpj */
	if( ga0->eda_no == -1 ) eda_st[0] = '\0';
	else sprintf(eda_st,"_%d",ga0->eda_no);

	if( fname == NULL ) {// TSPLIB,VRPLIBłȂƂ
		sprintf(ofname,"ga_result%d%s.txt",gap->cross_typ,eda_st);
	}
	else {	// TSPLIB,VRPLIBf[^̎́At@C*_tsp_res[0-9].txtƂ
		strcpy(ofname,fname);
		poi= strrchr(ofname,'.');
		if( poi == NULL ) goto quit;
		CHKB(1,gap->problem_type,5);
		if( gap->problem_type < 1 || gap->problem_type > 5 ) goto quit;
		sprintf(poi, "_%s_res%d%s.txt",problem_type_st[gap->problem_type], gap->cross_typ,eda_st);
	}
	if( (fp = fopen(ofname,"w")) == NULL )	 goto quit;

	// ̃t@C
	if( fname != NULL ) {
		fprintf(fp,"DATA_NAME:%s\n",fname);
	}
	else {
		fprintf(fp,"DATA_NAME:%s\n","Not TSPLIB");
	}
	/* s ݎ擾 */
	timer = time(NULL);
	local = localtime(&timer); /* nɕϊ */
	/* n ϊ\ */
	fprintf(fp,"s: %4d/%02d/%02d %02d:%02d:%02d\n"
		,local->tm_year + 1900, local->tm_mon + 1, local->tm_mday, local->tm_hour, local->tm_min, local->tm_sec);

	/* ga1_def.txt̓evg */
	Gap_print( fp, gap);
	fprintf(fp,"\nDIMENSION : %d\n",gap->gene_number);

	fprintf(fp,"TOUR_SECTION\n");
	for( i = 0; i < gap->gene_number; i++ ) {
		fprintf(fp,"%d\n",ans[i]+1);   // 1n܂Ƃ
	}
	fprintf(fp,"\n*** p[^łCOST&FITNESS ****\n");
	fprintf(fp,"TOTAL_COST : %lf\n",sagyo_max);
	fprintf(fp,"FITNESS : %lf\n",fitness);
	if( gap->problem_type == TSP || gap->problem_type == ATSP || gap->problem_type == MTSP ) { // TSP̎
		if( fname_opt != NULL && fname_opt[0] != '\0' ) {
			if( (fp2 = fopen(fname_opt,"r")) == NULL ) { rc = 0;  goto quit;  }
			rc = 1; // ̧ق
			// F̐
			while(fgets(buf, 256, fp2) != NULL) {
				if( strstr(buf,"DIMENSION") != NULL ) {
					if((poi = strchr(buf,':')) == NULL )	goto quit;
					dim = atoi(poi+1);
					if( dim != gap->gene_number )  goto quit;
				}
				if( strstr(buf,"TOUR_SECTION") != NULL ) break;
			}
			// œKipXj̓ǂݍ
			i = 0;
			ans2 = (int*) malloc( gap->gene_number*sizeof(*ans2) );
			if( ans2 == NULL ) { rc = -1; goto quit; }
			while(fgets(buf, 256, fp2) != NULL) {
				if( buf[0] == '\0' || buf[0] == '\n' ) continue;//KS130821add sǂݔ΂
//Psɉ̒lPo^ĂƂ͌Ȃ /TSPLIB/gr48.opt.tour, rd100.opt.tour Q KS130827chg
//				num = atoi(buf);
//				if( num <= 0 || num > gap->gene_number ) { CHKB(1, num, gap->gene_number); goto quit; }  //KS130821 CHKBǉ
//				ans2[i++] = num -1 ;  // On܂ɕϊ
//				if( i >= gap->gene_number)	  break;
				token = strtok(buf, "\t\n\r " );
				while( token != NULL ) {
					num = atoi(token);
					if( num <= 0 )  break;                   //Ō -1 ̒l̂ŔÔ
					if( num > gap->gene_number )  { CHKB(1, num, gap->gene_number); goto quit; } //G[
					ans2[i++] = num -1 ;  // On܂ɕϊ
					if( i >= gap->gene_number)	  break;
						token = strtok(NULL, "\t\n\r " );
				}
				if( i >= gap->gene_number)	 break;
			}
			if( i != gap->gene_number ) { CHKB(gap->gene_number, i, gap->gene_number); goto quit; }  //KS130821 CHKBǉ
			//fitness2 = fitnes_func( ans2, gap->gene_number, &sagyo_max2, gap, ga0 );// problem_typeŕ
			fitness2 = ga0->bekiFITNES( ans2, gap->gene_number, &sagyo_max2, gap );
			/* œK̃RXgƓKxo */
			fprintf(fp,"\n*** œKt@C(%s)COST&FITNESS ****\n",fname_opt);
			fprintf(fp,"TOTAL_COST : %lf\n",sagyo_max2);
			fprintf(fp,"FITNESS : %lf\n",fitness2);
			*def_num = (sagyo_max-sagyo_max2)/sagyo_max2*100;
			fprintf(fp,"\nœKƂ̍ : %lf\n",*def_num);
#ifdef TEST  // ga`t@CɂSނɕύX㐔POO`POOOOOŎs@ʂCSVt@Co
			for( t_i = 0; t_i < 4;	t_i++ ) t[t_i].def_num = (t[t_i].kai - sagyo_max2)/sagyo_max2*100;
#endif
			/* Otpf[^t@C̍쐬 */
			out_gdata(ga0,ans2,gap->gene_number,0,"OPTt@C̃[g");
		}
		else {// œKt@CȂȂ̒l
#ifdef TEST  // ga`t@CɂSނɕύX㐔POO`POOOOOŎs@ʂCSVt@Co
		//œKt@CȂȂAie[g̍őljo͂
		/* t[y_i].def_numɂ̓ZbgȂ@ʂŃRg[ */
//		for( t_i = 0; t_i < 4;	t_i++ ) t[t_i].def_num = t[t_i].kai;
#endif
		}
	}
	else if( gap->problem_type == VRP || gap->problem_type == CVRP ) { // VRP̎́AœK̓f[^ɓĂ
		fprintf(fp,"\n*** [g**** %d \n",gap->allele_number);
		/* [gƂ̎̋o */
		for( i = 0; i < gap->allele_number; i++ ) {
			fprintf(fp,"[g:%d => %lf\n",i+1, ga0->route_num[i]);
		}
		fprintf(fp,"\n");
		if( fname_opt != NULL && fname_opt[0] != '\0' ) {
			if( (fp2 = fopen(fname_opt,"r")) == NULL ) { rc = 0;  goto quit;  }
			rc = 1; // ̧ق
			// œKipXj̓ǂݍ
			i = 0;
			ans2 = (int*) malloc( gap->gene_number*sizeof(*ans2) );
			if( ans2 == NULL )	{ rc = -1; goto quit; }
			ans2[i++] = 0;	 // ̧قɂOȂ@opt̃t@C͂On܂łON_̂悤
			sep_no = gap->gene_number - gap->allele_number +1 ;
			while(fgets(buf, 256, fp2) != NULL) {
				if( strstr(buf, "Route") == 0 ) continue;  //KS130820add Route ȊO̕Ɛ䂪ĈُI
				token=strtok(buf, "\t\n\r " ); // Route #1:ǂݔ΂
				token=strtok(NULL, "\t\n\r " );
				token=strtok(NULL, "\t\n\r " );
				while( token != NULL ) {
					num = atoi(token);
					if( num <= 0 || num > gap->gene_number )  goto quit;
					ans2[i++] = num ;
					token=strtok(NULL, "\t\n\r " );
				}
				if( i >= gap->gene_number)	  break;
				ans2[i++] = sep_no++; // Zp[^ǉ
			}
			if( i != gap->gene_number )   goto quit;
			//fitness2 = fitnes_func( ans2, gap->gene_number, &sagyo_max2, gap,ga0 );// problem_typeŕ
			fitness2 = ga0->bekiFITNES_VRP( ans2, gap->gene_number, &sagyo_max2, gap, &route_max) ; // rout_max̒ǉ 2015.11.20 YS
			/* œK̃RXgƓKxo */
			fprintf(fp,"\n*** œKt@C(%s)COST&FITNESS ****\n",fname_opt);
			fprintf(fp,"TOTAL_COST : %lf\n",sagyo_max2);
			fprintf(fp,"FITNESS : %lf\n",fitness2);
			fprintf(fp,"\n*** œK̃[g**** %d \n",gap->allele_number);
			/* [gƂ̎̋o */
			for( i = 0; i < gap->allele_number; i++ ) {
				fprintf(fp,"[g:%d => %lf\n",i+1, ga0->route_num[i]);
			}
			// VRP̍œK̒i莞ԍv̌vZĔrĂAɂȂȂ̂ŁAODT|Ďg
			//sagyo_max2 /= 2.0;
			//fprintf(fp,"CTOTAL_COST : %lf\n",sagyo_max2);
			//*def_num = (sagyo_max-sagyo_max2)/sagyo_max2*100;
			//fprintf(fp,"\nœKƂ̍ : %lf\n",*def_num);
			/* Otpf[^t@C̍쐬 */
			out_gdata(ga0,ans2,gap->gene_number,0,"OPTt@C̃[g");
		}
		else {
			sagyo_max2 = ga0->optimalValue; // .vrpt@C̃RgOptimal value
			// ̒ĺAN_܂Ŗ߂Ă̂ŁAB߂Â邽߁AQŊĂ݂iӖ͂Ȃj
			// ̒ĺAe[g̍v
			sagyo_max2 = sagyo_max2 / 2.0;
			fprintf(fp,"\n*** œKCOST ****\n");
			fprintf(fp,"TOTAL_COST(Optimal value̔j : %lf\n",sagyo_max2);
			if( sagyo_max2 > 0 )  //KS20150721 if ǉ
			*def_num = (sagyo_max-sagyo_max2)/sagyo_max2*100;
			fprintf(fp,"\nœKƂ̍ : %lf\n",*def_num);
		}
#ifdef TEST  // ga`t@CɂSނɕύX㐔POO`POOOOOŎs@ʂCSVt@Co
		//uqo͍œKiiƂꍇ́j킩Ȃ̂ŁAie[g̍őljo͂
		//for( t_i = 0; t_i < 4;	t_i++ ) t[t_i].def_num = (t[t_i].kai - sagyo_max2)/sagyo_max2*100;
		/* t[y_i].def_numɂ̓ZbgȂ@ʂŃRg[ */
//		for( t_i = 0; t_i < 4;	t_i++ ) t[t_i].def_num = t[t_i].kai;
#endif
	}
	else CHKA(gap->problem_type,gap->problem_type,gap->problem_type);
	//rc = 0;
quit:
	if( ans2 != NULL ) free(ans2);
	if( fp != NULL ) fclose(fp), fp = NULL;
	if( fp2 != NULL ) fclose(fp2), fp2 = NULL;
	return(rc);
}
#include <time.h>

/*	ID_gatsp_go  srof`ŉ
********************************************************************/
int gatsp_go( /* rc = 1:œKt@C@rc= 0:œKt@CȂ *//* œKt@CǂłȂ̂ŁAłOԂ*/
struct gaparm	*gparm,
int 	algotype,
double	*def_num,
class GA1 *ga0,
double	*sagyo_max)   // Ss
{
	int 	rc=0, i;
//	double	fitness;
	//	double	(*fitnes_func)(int*, int, double *,struct gaparm *,class GA1 *ga0) = NULL;		/* (i)KxvZ֐ double *kaiǉ */
	//class GA1 ga1;
	/* GAp[^Rs[ */
	ga0->gap = *gparm;
	//if( ga0->fitnes_func == NULL ) ga0->fitnes_func = &GA1::bekiFITNES; // ftHg͂srop// problem_typeŕ

	/* TSPp̃GAmۂƏAsrokhaCuqokhãf[^Zbg */
	if ( (rc=tspINIT(ga0)) < 0 ) goto equit ;
	if( algotype == 0 ) {		// GÂƂ
		//memset( ga0->ans, 0, sizeof(int) * ga0->gap.gene_number ) ;
		if ( ga0->gap.locus_unique )	rc = ga1_go( ga0, gaINITMK2 ) ;//1 `qƂɂƂ肤`qقȂ
		else							rc = ga1_go( ga0, NULL ) ;
		if( DBGF[20]) fprintf(logfp,"genetic algorithm type(%d) rc(%d)\n", algotype, rc) ;
	} else {								// q[XeBbN̎ ݃q[XeBbN̓eΏۊO 2013.05.24 YS
		rc = huristic( ga0->gap.gene_number, ga0->gap.allele_number, ga0->sagyo, ga0->allele, ga0->ans );
		fprintf(logfp,"huristic rc(%d)\n", rc) ;
	}
	if ( rc < 0 ) goto equit ;	/* rװ */

	if( DBGF[20]) {
		fprintf(logfp,"ans=(") ;
		for (i=0 ; i<ga0->gap.gene_number ; i++ ) fprintf(logfp,"%d,",ga0->ans[i]) ;
		fprintf(logfp,")\n") ;
	}
	//fitness = ga0->fitnes_func( ga0->ans, ga0->gap.gene_number, &ga0->sagyo_max, &ga0->gap );
	//ga0->fitness = fitness;
	if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) {// problem_typeŕ
		ga0->fitness = ga0->bekiFITNES_VRP( ga0->ans, ga0->gap.gene_number, &ga0->sagyo_max, &ga0->gap, &ga0->route_max) ; // rout_max̒ǉ 2015.11.20 YS
		//ga0->kai = ga0->route_max ; /* 13/06/19 */
	}
	else if( ga0->gap.problem_type == TSP || ga0->gap.problem_type == ATSP || ga0->gap.problem_type == MTSP ) {
		ga0->fitness = ga0->bekiFITNES( ga0->ans, ga0->gap.gene_number, &ga0->sagyo_max, &ga0->gap) ;
		//ga0->kai = kai ; /* 98/08/24 */
	}
	else CHKA(-1,-1,-1);

	//sagyo_max = Eval( gap.gene_number, gap.allele_number, sagyo, ans, mcn );
	*sagyo_max = ga0->sagyo_max;
	if( DBGF[20]) 	fprintf(logfp,"sagyo_max(%lf)\n",ga0->sagyo_max) ;
	*gparm = ga0->gap;	// TSPLIBǂݍŕύXlԂ 2013.01.21
	// t@Co
	// œK̃t@CȂÃt@CƂُ̍o
	/* krAтlsrǒʂo͂
	/*if( (rc = Result_print(ga0->ans, ga0->sagyo_max, fitness, &ga0->gap, ga0->gap.prob_fname, ga0->gap.optsol_fname,def_num
	/*	, ga0->fitnes_func, ga0)) < 0 )	goto equit;
	*/
	return( rc );
equit :	/* rŴװ */
	//tspFINAL() ;
	return( rc ) ;
}

