/*
 * FILE 	 : qsortx.cpp
 * FUNCTION  : z̓YXgNCbN\[gB
 * Copyright (C) 2012 Sogen System Co., Ltd
 * AUTHER	 : 2012/05/25 N.Tsuchiya
   NT120904 ύX
	  yz
	  l̃f[^Ă\͗ȂBqsort()ł͂Qlf[^O(N**2)ƂȂB
	  l̃f[^͕̏ۑBqsort()ł͕ۑȂB
	  yz
	  f[^ɔႵYzgB
  NT130726 xqsort.hƕϐARgȂǂ𓝈
  NT130726 œ(L[/T)[vŔr񐔂P팸B20%Ȃ
 */
#include <assert.h>
#include <stdio.h>

//#define Size_t unsigned int
//#define Size_t size_t
#define Size_t int
#define QSORTX_COMP (int (*)(void *,const int,const int))

void qsortx(
	Size_t *ary,	 //io ́F\[gΏۂ̓YzBóF\[g̓YzB
	Size_t n_ary,	 //i  \[gΏۂ̃f[^Bary[]̃f[^B
	int (*p_comp) (void *dat, const int p, const int q), //i  r֐Bqsort()ƓlɂQ&dat[]ĔrB
		//dat[p]==dat[q]̎͂OԂΏ[BYp, q̒l͂̊֐ŔrĂB
	void *dat)		//i \[gΏۂ̔Cӌ^̔z
{
	register Size_t lo, hi, lok, hik;
	Size_t midkey;
	Size_t mid, lostk[64], histk[64];
	int n_stk, cmp;

	if( n_ary >= 2 ) {
		n_stk = 0;
		lo = 0; hi = n_ary - 1; 		     //\[gԁF[lo,hi]
		while( 1 ) { assert(lo < hi);		 //Qȏf[^͂
			mid = lo + ((hi - lo) >> 1);	 //(lo+hi) ̃I[ot[l
			midkey = ary[mid]; ary[mid] = ary[lo]; //̒lL[ƂBary[lo]󂯂
			lok = lo; hik = hi;
			while( 1 ) {
				for( ; lok < hik; --hik ) {  //L[菬̂T
					if( (cmp = (*p_comp)(dat, ary[hik], midkey)) < 0 ) break;
					if( cmp == 0 && ary[hik] < midkey ) break;
				}
				if( lok == hik ) break;      //ifVC6+BoundsCheckerŃN NT120523
				ary[lok] = ary[hik];	     //ary[hik]͋󂫂ɂȂBlok=hikmȂ܂Ȃ
				++lok; //NT130726add
				for( ; lok < hik; ++lok ) {  //L[傫̂T
					if( (cmp = (*p_comp)(dat, ary[lok], midkey)) > 0 ) break;
					if( cmp == 0 && ary[lok] > midkey ) break;
				}
				if( lok == hik ) break;      //ifVC6+BoundsCheckerŃN NT120523
				ary[hik] = ary[lok];	     //ary[lok]͋󂫂ɂȂBlok=hikmȂ܂Ȃ
				--hik; //NT130726add
			}	assert(lok == hik); 	     //lok == hik̂͂
			ary[lok] = midkey;			     //L[󂫂ɖ߂Bary[lok]͋󂫁Blok == hik

			//̃\[gԁF[lo, hik-1] [hik+1,hi] (lok = hik)
			if( hik > mid ) {  assert(hik-lo >= hi-hik);		//傫(lo)X^bNɓ
				if( hik + 1 < hi ) { assert(n_stk<64); //ZɂQȏf[^
					lostk[n_stk] = lo; histk[n_stk] = hik - 1; ++n_stk; //X^bNɓāAォ\[g
					lo	= hik + 1;			 //lo:󂫂̈ʒu
				} else if( lo + 1 < hik ) {  //Z̓\[gsvBɂQȏf[^
					hi = hik - 1;
				} else {
					if( --n_stk < 0 ) break; //X^bNɂȂI
					lo = lostk[n_stk], hi = histk[n_stk]; //
				}
			} else { assert(hik-lo <= hi-hik);
				if( lo + 1 < hik) { //assert(n_stk<64); //ZɂQȏf[^
					lostk[n_stk] = hik + 1; histk[n_stk] = hi; ++n_stk; //X^bNɓāAォ\[g
					hi = hik - 1;
				} else if( hik + 1 < hi ) {  //Z̓\[gsvBɂQȏf[^
					lo = hik + 1;
				} else {                     //̒Pȉ
					if( --n_stk < 0 ) break; //X^bNɂȂI
					lo = lostk[n_stk], hi = histk[n_stk]; //
				}
			}
		}
	}
#if defined (_DEBUG)
	for (mid = 1; mid < n_ary; mid++) {
		if( (cmp = (*p_comp)(dat, ary[mid-1], ary[mid])) < 0 ) continue;
		if( cmp == 0 && ary[mid-1] < ary[mid] ) continue;
		printf("!!!\[głĂȂ\n"); //assert(cmp<=0);
		break;
	}
#endif
}
//\[gʂary[]ɂ\[gΏۂ̔zdat[]n(m)̈ړŕבւB
//		R[h4096܂ŁB
//		swapɃf[^]񐔂ňł1.5mȉɌ炵Ă
#define Ary_adr(k) ((k) * recl + (char*)dat)
#define Copy(to, fr) for(ic = 0; ic < recl; ++ic ) *((char*)(to) + ic) = *((char*)(fr) + ic)
void orderm(
  void *dat,	  //i \[gΏۂ̔Cӌ^̔z
  Size_t n_ary,   //i \[gΏۂ̃f[^
  Size_t recl,	  //i \[gΏۂ̃R[h
  Size_t *ary)	   //o Size_t[n_ary]̃[NzBary[k]ɂ͏ʂ̃f[^ԍԂBk=0,1,..n_ary-1
{
	Size_t pred, next, mask1, ic, k;
  char bf[4096];
  mask1 = (~0); 	  //0x7fffffff
  mask1 = ~ (mask1 >> 1);	 //0x80000000
  for( k = 0; k <n_ary; ++k ) {
	if( ary[k] & mask1 ) { ary[k] ^= mask1; continue; } //ړςȂ擪rbg߂ĎցB
	if( ary[k] == k ) continue;
	Copy(bf, Ary_adr(k));	   //bf[]ɃR[hޔāAdat̂Ԗڂ󂯂B
	pred = k;
	for( next = ary[k]; next != k;	) {
	  Copy(Ary_adr(pred), Ary_adr(next));
	  pred = next;
	  next = ary[next];
	  ary[pred] |= mask1;	   //擪rbgIBړς݂ɂ
	}
	Copy(Ary_adr(pred), bf);
  }
}
//------------------------ sample main -----------------------------
//#define XQSORT_TEST
#if defined XQSORT_TEST

#include <stdlib.h>  //for rand()
#include <string.h>
#include <time.h>

#define IDX_TYPE int //int or Size_t or...

struct Node {
  int x, y;  //_̍Wl
};
static int compA(void *pp0, const int p,const int q){ //<== staticYȂ
  int rc;
  struct Node *pp;
  pp = (struct Node *)pp0;
  if	 ( pp[p].x < pp[q].x ) rc = -1;
  else if( pp[p].x > pp[q].x ) rc = 1;
  else if( pp[p].y < pp[q].y ) rc = -1;
  else if( pp[p].y > pp[q].y ) rc = 1;
  else rc = 0; //p, q̔r͕svB
  return rc;
}
#define MAXDATA 50000
struct Node pl[] = { {1, 2}, {3, 1}, {1, 0}, {0, 1}, {0, 0}, {-1, 0}, {0, -1} };
struct Node pp[MAXDATA], sw[MAXDATA];
int wkList[MAXDATA];

//\[gʂ̃`FbN
int checkIdx(struct Node *pp, int nsize, int *idxList)
{
  int k, idx;
  //̃`FbN
  for (k = 1; k < nsize; k++) {
	if( compA(pp, idxList[k-1], idxList[k]) > 0 ) {
	  printf("\[głĂȂ\n");
	  break;
	}
  }
  if( idxList != 0 ) {
	for( k = 0; k < nsize; ++k ) wkList[k] = -1;
	//0..n-1P񂸂邩̃`FbN
	for( k = 0; k < nsize; ++k ) {
	  idx = idxList[k];
	  if( idx < 0 || idx >= nsize ) {
		printf(" %d Ԗڂ̃CfNX(%d)͈͊O\n", k, idx);
	  } else if( wkList[idx] != -1 ) {
		printf(" %d Ԗڂ̃CfNX(%d)do^\n", k, idx);
	  } else {
		wkList[idx] = 1;
	  }
	}
	//Ԃ̃`FbN
	for( k = 0; k < nsize; ++k ) {
	  if( wkList[idx] == -1 ) {
		printf(" %d Ԗڂ̃CfNX(%d)ss\n", k, idx);
	  }
	}
  }
  return 0;
}

void gen_rand(struct Node *pp, int num, int base)
{
  while( --num >= 0) {
	pp[num].x = rand() % base;
	pp[num].y = rand() % base;
  }
}
int main()
{
  int i, k, num, base;
  int ary[MAXDATA];
  time_t now1, now2;
  //\[gf[^쐬
  base = 10000;
  base = 2;
  gen_rand( pp, MAXDATA, base );

//	qsort(&pp[0], MAXDATA, 8, compA);  //qsorteXg
  //\̔z̓YXgA\[g
  //0,1,2,3ĂяoeXg
  for( num = 0; num < 100; ++num ) {
	for( k = 0; k < 10; ++k ) {
	  gen_rand( pp, num, base );
	  for( i = 0; i < num; ++i ) ary[i] = i;
	  qsortx(ary, num, compA, &pp[0]);	//ĂяoeXg
	  checkIdx( pp, num, ary);
	}
  }
  num = MAXDATA;
  gen_rand( pp, num, base );
  now1 = clock();
  for( k = 0; k < 200; ++k ) {
	memcpy(sw, pp, sizeof(pp));
	//\̔z\[g
	for( i = 0; i < num; ++i ) ary[i] = i;
	qsortx(ary, num, compA, &sw[0]);
//	checkIdx( sw, num, ary);
//	  qsort (&sw[0], num, 8, compA);	 //base=2̂ƂO(N**2)ɂȂ
//	  checkIdx( sw, num, 0);
  }
  now2 = clock();
  printf("%d  cpu %d\n", k, (int)(now2 - now1) ); //k=300 cpu=3531
  //
#if defined (_DEBUG)
  scanf("%c", &k);
#endif
  return 0;
}
#endif //defined XQSORT_TEST
